import * as i0 from '@angular/core';
import { Injectable, Component, NgModule, EventEmitter, Output, Input, ViewChild } from '@angular/core';
import * as i2 from 'octali-utils';
import { OctaliUtilsModule, LoggerService, DisplayerService, PipesModule, TextRichComponentModule, FileChooserComponentModule } from 'octali-utils';
import { __awaiter } from 'tslib';
import * as i1 from '@angular/fire/firestore';
import { AngularFirestore } from '@angular/fire/firestore';
import { BehaviorSubject, combineLatest } from 'rxjs';
import { map } from 'rxjs/operators';
import * as i3 from 'octali-firebase-utils';
import { FileService } from 'octali-firebase-utils';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule, Validators, FormBuilder } from '@angular/forms';
import { IonicModule, ModalController, NavParams } from '@ionic/angular';

class OctaliShopService {
    constructor() { }
}
OctaliShopService.ɵprov = i0.ɵɵdefineInjectable({ factory: function OctaliShopService_Factory() { return new OctaliShopService(); }, token: OctaliShopService, providedIn: "root" });
OctaliShopService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
OctaliShopService.ctorParameters = () => [];

class OctaliShopComponent {
    constructor() { }
    ngOnInit() {
    }
}
OctaliShopComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-octali-shop',
                template: `
    <p>
      octali-shop works!
    </p>
  `
            },] }
];
OctaliShopComponent.ctorParameters = () => [];

class OctaliShopModule {
}
OctaliShopModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    OctaliShopComponent,
                ],
                imports: [],
                providers: [
                    OctaliUtilsModule
                ],
                exports: [
                    OctaliShopComponent,
                ]
            },] }
];

class Category {
    constructor() {
        this.id = "";
        this.name = "";
        this.statut = "wait";
        this.description = "";
        this.image = null;
        this.thumb = null;
        this.parent = "";
        this.children = [];
        this.level = 0;
        this.features = [];
        this.nbProducts = 0;
        this.products = [];
    }
    static setByDocument(doc) {
        let category = new Category();
        category.setId(doc.id);
        category.name = doc.name;
        category.statut = doc.statut;
        category.description = doc.description;
        if (doc.image)
            category.image = doc.image;
        if (doc.thumb)
            category.thumb = doc.thumb;
        if (doc.parent)
            category.parent = doc.parent;
        if (doc.children)
            category.children = doc.children;
        category.level = doc.level;
        if (doc.features)
            category.features = doc.features;
        if (doc.nbProducts)
            category.nbProducts = doc.nbProducts;
        if (doc.products)
            category.products = doc.products;
        return category;
    }
    static mapToBdd(category) {
        if (category == null)
            return {};
        return {
            id: category.getId(),
            name: category.getName(),
            statut: category.getStatut(),
            description: category.getDescription(),
            image: category.getImage(),
            thumb: category.getThumb(),
            parent: category.getParent(),
            children: category.getChildren(),
            level: category.getLevel(),
            features: category.getFeatures(),
            nbProducts: category.getNbProducts(),
            products: category.getProducts()
        };
    }
    getId() {
        return this.id;
    }
    setId(id) {
        this.id = id;
    }
    getName() {
        return this.name;
    }
    setName(name) {
        this.name = name;
    }
    getDescription() {
        return this.description;
    }
    setDescription(description) {
        if (description == undefined)
            description = '';
        this.description = description;
    }
    getStatut() {
        return this.statut;
    }
    setStatut(statut) {
        if (statut == undefined)
            statut = '';
        this.statut = statut;
    }
    getThumb() {
        return this.thumb;
    }
    setThumb(thumb) {
        if (thumb == undefined)
            thumb = new Map();
        this.thumb = thumb;
    }
    getImage() {
        return this.image;
    }
    setImage(image) {
        if (image == undefined)
            image = new Map();
        this.image = image;
    }
    getParent() {
        return this.parent;
    }
    setParent(parent) {
        if (parent == undefined)
            parent = "";
        this.parent = parent;
    }
    getChildren() {
        return this.children;
    }
    hasChildren(child) {
        return this.children.includes(child);
    }
    addChild(child) {
        if (this.hasChildren(child))
            return false;
        this.children.push(child);
        return true;
    }
    removeChild(child) {
        if (!this.hasChildren(child))
            return false;
        this.children.splice(this.children.indexOf(child), 1);
        return true;
    }
    removeChildren(children) {
        for (let child of children)
            if (!this.hasChildren(child))
                return false;
        for (let child of children)
            this.children.splice(this.children.indexOf(child), 1);
        return true;
    }
    setChildren(children) {
        this.children = children;
    }
    getLevel() {
        return this.level;
    }
    setLevel(lvl) {
        this.level = lvl;
    }
    getFeatures() {
        return this.features;
    }
    setFeatures(features) {
        this.features = features;
    }
    addFeature(feature) {
        if (this.features.includes(feature))
            return false;
        this.features.push(feature);
        return true;
    }
    removeFeature(feature) {
        if (!this.features.includes(feature))
            return false;
        this.features.splice(this.features.indexOf(feature), 1);
        return true;
    }
    getNbProducts() {
        return this.nbProducts;
    }
    setNbProduct(nb) {
        this.nbProducts = nb;
    }
    getProducts() {
        return this.products;
    }
    setProduct(products) {
        this.products = products;
    }
}

class Feature {
    constructor() {
        this.values = []; // valeurs ou valeur
        this.id = "";
        this.name = "";
        this.description = "";
        this.type = "";
        this.typeValue = "";
        this.nameValue = "";
        this.multiple = false;
        this.withValue = "none";
        this.withCategory = false;
        this.values = [];
        this.icon = null;
        this.display = {};
        this.order = 0;
        this.filter = {};
    }
    static setByDocument(doc) {
        let feature = new Feature();
        feature.setId(doc.id);
        feature.setName(doc.name);
        feature.setDescription(doc.description);
        feature.setType(doc.type);
        feature.setTypeValue(doc.typeValue);
        feature.setNameValue(doc.nameValue);
        feature.setMultiple(doc.multiple);
        feature.setWithValue(doc.withValue);
        feature.setWithCategory(doc.withCategory);
        let values = new Array();
        ;
        if (doc.type == "number")
            values = new Array();
        if (doc.type == "string")
            values = new Array();
        for (let v of doc.values) {
            if (doc.type == "number")
                values.push(Number(v));
            if (doc.type == "string")
                values.push(v);
            if (doc.type == "map") {
                let vs = {};
                if (doc.typeValue[0] == "number")
                    vs[doc.display.values[0]] = Number(v[doc.display.values[0]]);
                else
                    vs[doc.display.values[0]] = v[doc.display.values[0]];
                if (doc.typeValue[1] == "number")
                    vs[doc.display.values[1]] = Number(v[doc.display.values[1]]);
                else
                    vs[doc.display.values[1]] = v[doc.display.values[1]];
                values.push(vs);
            }
        }
        feature.setValues(doc.values);
        feature.setIcon(doc.icon);
        feature.setDisplay(doc.display);
        feature.setOrder(doc.order);
        feature.setFilter(doc.filter);
        return feature;
    }
    static mapToBdd(feature) {
        if (feature == null)
            return {};
        return {
            id: feature.id,
            name: feature.name,
            description: feature.description,
            type: feature.type,
            typeValue: feature.typeValue,
            nameValue: feature.nameValue,
            multiple: feature.multiple,
            withCategory: feature.withCategory,
            withValue: feature.withValue,
            values: feature.values,
            display: feature.display,
            icon: feature.icon,
            order: feature.order,
            filter: feature.filter
        };
    }
    getId() {
        return this.id;
    }
    setId(id) {
        this.id = id;
    }
    getName() {
        return this.name;
    }
    setName(name) {
        this.name = name;
    }
    getDescription() {
        return this.description;
    }
    setDescription(description) {
        this.description = description;
    }
    getType() {
        return this.type;
    }
    setType(type) {
        this.type = type;
    }
    getTypeValue() {
        return this.typeValue;
    }
    setTypeValue(type) {
        this.typeValue = type;
    }
    getNameValue() {
        return this.nameValue;
    }
    setNameValue(name) {
        this.nameValue = name;
    }
    getMultiple() {
        return this.multiple;
    }
    setMultiple(multiple) {
        this.multiple = multiple;
    }
    getWithCategory() {
        return this.withCategory;
    }
    setWithCategory(withCategory) {
        this.withCategory = withCategory;
    }
    getWithValue() {
        return this.withValue;
    }
    setWithValue(withValue) {
        this.withValue = withValue;
    }
    getValues() {
        return this.values;
    }
    setValues(values) {
        this.values = values;
    }
    addValue(value) {
        if (this.values.includes(value) || value == "" || value == undefined || value == null)
            return false;
        this.values.push(value);
        return true;
    }
    getIcon() {
        return this.icon;
    }
    setIcon(icon) {
        this.icon = icon;
    }
    getDisplay() {
        return this.display;
    }
    setDisplay(display) {
        this.display = display;
    }
    getOrder() {
        return this.order;
    }
    setOrder(order) {
        this.order = order;
    }
    getFilter() {
        return this.filter;
    }
    setFilter(filter) {
        this.filter = filter;
    }
}

class Product {
    constructor() {
        this.id = "";
        this.title = "";
        this.subtitle = "";
        this.description = "";
        this.short_description = "";
        this.strengths = [];
        this.ean = "";
        this.manufacturer = "";
        this.categories = [];
        this.sold = false;
        this.cost = 0;
        this.price = 0;
        this.sold_price = 0;
        this.discount = false;
        this.wprice = 0;
        this.sold_wprice = 0;
        this.wdiscount = false;
        this.key_seo = [];
        this.description_seo = "";
        this.hashtag = "";
        this.shipping_cost = 0;
        this.weight = 0;
        this.width = 0;
        this.height = 0;
        this.length = 0;
        this.quantity = 0;
        this.features = [];
        this.variations = [];
        this.variationName = "";
        this.combinations = [];
        this.nbCombinations = 0;
        this.image = new Map();
        this.thumb = new Map();
        this.zoom = new Map();
        this.images = new Array();
        this.createdAt = "";
        this.availableAt = "";
        this.supplyAt = "";
        this.statut = "wait";
        this.specialShop = false;
        this.specialWeb = false;
        this.discontinued = false;
        this.samePrice = true;
        this.comments = new Array();
        this.nbComments = 0;
    }
    static setByDocument(doc) {
        let prod = new Product();
        prod.id = doc.id;
        prod.title = doc.title;
        prod.subtitle = doc.subtitle;
        prod.description = doc.description;
        prod.short_description = doc.short_description;
        prod.strengths = doc.strengths;
        prod.ean = doc.ean;
        prod.manufacturer = doc.manufacturer;
        prod.categories = doc.categories;
        prod.sold = doc.sold;
        prod.cost = doc.cost;
        prod.price = doc.price;
        prod.sold_price = doc.sold_price;
        prod.discount = doc.discount;
        prod.wprice = doc.wprice;
        prod.sold_wprice = doc.sold_wprice;
        prod.wdiscount = doc.wdiscount;
        prod.key_seo = doc.key_seo;
        prod.description_seo = doc.description_seo;
        prod.hashtag = doc.hashtag;
        prod.shipping_cost = doc.shipping_cost;
        prod.weight = doc.weight;
        prod.width = doc.width;
        prod.height = doc.height;
        prod.length = doc.length;
        prod.quantity = doc.quantity;
        prod.features = doc.features;
        prod.variations = doc.variations;
        prod.variationName = doc.variationName;
        prod.combinations = doc.combinations;
        prod.nbCombinations = doc.nbCombinations;
        if (doc.image == [])
            prod.image = new Map();
        else
            prod.image = doc.image;
        if (doc.thumb == [])
            prod.thumb = new Map();
        else
            prod.thumb = doc.thumb;
        if (doc.zoom == [])
            prod.zoom = new Map();
        else
            prod.zoom = doc.zoom;
        prod.images = doc.images;
        prod.createdAt = doc.createdAt;
        prod.availableAt = doc.availableAt;
        prod.supplyAt = doc.supplyAt;
        prod.statut = doc.statut;
        prod.specialShop = doc.specialShop;
        prod.specialWeb = doc.specialWeb;
        prod.discontinued = doc.discontinued;
        prod.samePrice = doc.samePrice;
        prod.comments = doc.comments;
        prod.nbComments = doc.nbComments;
        return prod;
    }
    getId() {
        return this.id;
    }
    setId(id) {
        this.id = id;
    }
    getTitle() {
        return this.title;
    }
    setTitle(title) {
        this.title = title;
    }
    getSubTitle() {
        return this.subtitle;
    }
    setSubtitle(title) {
        this.subtitle = title;
    }
    getShortDescription() {
        return this.short_description;
    }
    setShortdescription(description) {
        this.short_description = description;
    }
    getDescription() {
        return this.description;
    }
    setDescription(description) {
        this.description = description;
    }
    getEan() {
        return this.ean;
    }
    setEan(ean) {
        this.ean = ean;
    }
    hasStrength(strength) {
        return this.strengths.includes(strength.toLowerCase());
    }
    getStrengths() {
        return this.strengths;
    }
    setStrengths(strengths) {
        this.strengths = strengths;
    }
    addStrength(strength) {
        if (this.hasStrength(strength))
            return false;
        this.strengths.push(strength.toLowerCase());
        return true;
    }
    getMaker() {
        return this.manufacturer;
    }
    setMaker(manufacturer) {
        this.manufacturer = manufacturer;
    }
    hasCategory(category) {
        return this.categories.includes(category);
    }
    getCategories() {
        return this.categories;
    }
    setCategories(categories) {
        this.categories = categories;
    }
    addCategory(category) {
        if (this.hasCategory(category))
            return false;
        this.categories.push(category);
        return true;
    }
    removeCategory(category) {
        if (!this.hasCategory(category))
            return false;
        this.categories.splice(this.categories.indexOf(category), 1);
        return true;
    }
    getSold() {
        return this.sold;
    }
    setSold(sold) {
        this.sold = sold;
    }
    getCost() {
        return this.cost;
    }
    setCost(cost) {
        this.cost = cost;
    }
    getPrice() {
        return this.price;
    }
    setPrice(price) {
        this.price = price;
    }
    getSoldPrice() {
        return this.sold_price;
    }
    setSoldPrice(price) {
        this.sold_price = price;
    }
    isDiscount() {
        return this.discount;
    }
    setDiscount(discount) {
        this.discount = discount;
    }
    getWPrice() {
        return this.wprice;
    }
    setWPrice(price) {
        this.wprice = price;
    }
    getSoldWPrice() {
        return this.sold_wprice;
    }
    setSoldWPrice(price) {
        this.sold_wprice = price;
    }
    isWDiscount() {
        return this.wdiscount;
    }
    setWDiscount(discount) {
        this.wdiscount = discount;
    }
    getKeySeo() {
        return this.key_seo;
    }
    setKeySeo(keys) {
        this.key_seo = keys;
    }
    getDescriptionSeo() {
        return this.description_seo;
    }
    setDescriptionSeo(description) {
        this.description_seo = description;
    }
    getHashtag() {
        return this.hashtag;
    }
    setHashtag(tag) {
        this.hashtag = tag;
    }
    getShippingCost() {
        return this.shipping_cost;
    }
    setShippingCost(cost) {
        this.shipping_cost = cost;
    }
    getWeight() {
        return this.weight;
    }
    setWeight(weight) {
        this.weight = weight;
    }
    getWidth() {
        return this.width;
    }
    setWidth(width) {
        this.width = width;
    }
    getHeight() {
        return this.height;
    }
    setHeight(height) {
        this.height = height;
    }
    getLength() {
        return this.length;
    }
    setLength(length) {
        this.length = length;
    }
    getQuantity() {
        return this.quantity;
    }
    setQuantity(quantity) {
        this.quantity = quantity;
    }
    hasFeature(feature) {
        return this.features.includes(feature);
    }
    getFeatures() {
        return this.features;
    }
    setFeatures(features) {
        this.features = features;
    }
    addFeature(feature) {
        if (this.hasFeature(feature))
            return false;
        if (!this.features)
            this.features = [];
        this.features.push(feature);
        return true;
    }
    removeFeature(feature) {
        if (!this.hasFeature(feature))
            return false;
        this.features.splice(this.features.indexOf(feature), 1);
        return true;
    }
    hasVariation(variation) {
        return this.variations.includes(variation);
    }
    getVariations() {
        return this.variations;
    }
    setVariations(variations) {
        this.variations = variations;
    }
    addVariation(variation) {
        if (this.hasVariation(variation))
            return false;
        if (!this.variations)
            this.variations = [];
        this.variations.push(variation);
        return true;
    }
    removeVariation(variation) {
        if (!this.variations || this.variations.length == 0 || !this.hasVariation(variation))
            return false;
        this.variations.splice(this.variations.indexOf(variation), 1);
        return true;
    }
    hasCombination(combination) {
        return this.combinations.includes(combination);
    }
    getCombination() {
        return this.combinations;
    }
    setCombinations(combinations) {
        this.combinations = combinations;
    }
    addCombination(combination) {
        if (this.hasCombination(combination))
            return false;
        if (!this.combinations)
            this.combinations = [];
        this.combinations.push(combination);
        return true;
    }
    removeCombination(combination) {
        if (!this.combinations || this.combinations.length == 0 || !this.hasCombination(combination))
            return false;
        this.combinations.splice(this.combinations.indexOf(combination), 1);
        return true;
    }
    getImage() {
        return this.image;
    }
    setImage(image) {
        this.image = image;
    }
    getThumb() {
        return this.thumb;
    }
    setThumb(image) {
        this.thumb = image;
    }
    getZoom() {
        return this.zoom;
    }
    setZoom(image) {
        this.zoom = image;
    }
    getImages() {
        return this.images;
    }
    setImages(images) {
        this.images = images;
    }
    getCreatedAt() {
        return this.createdAt;
    }
    setCreatedAt(date) {
        this.createdAt = date;
    }
    getAvailableAt() {
        return this.availableAt;
    }
    setAvailableAt(date) {
        this.availableAt = date;
    }
    getSupplyAt() {
        return this.supplyAt;
    }
    setSupplyAt(date) {
        this.supplyAt = date;
    }
    getStatut() {
        return this.statut;
    }
    setStatut(statut) {
        this.statut = statut;
    }
    isSpecialShop() {
        return this.specialShop;
    }
    setSpecialShop(is) {
        this.specialShop = is;
    }
    isSpecialWeb() {
        return this.specialWeb;
    }
    setSpecialWeb(is) {
        this.specialWeb = is;
    }
    isDiscontinued() {
        return this.discontinued;
    }
    setDiscontinued(is) {
        this.discontinued = is;
    }
    getNbCombination() {
        return this.nbCombinations;
    }
    setNbCombination(nb) {
        this.nbCombinations = nb;
    }
    getVariationName() {
        return this.variationName;
    }
    setVariationName(name) {
        this.variationName = name;
    }
    isSamePrice() {
        return this.samePrice;
    }
    setSamePrice(same) {
        this.samePrice = same;
    }
}

class Declination {
    constructor() {
        this.id = "";
        this.sold = false;
        this.cost = 0;
        this.price = 0;
        this.sold_price = 0;
        this.discount = false;
        this.wprice = 0;
        this.sold_wprice = 0;
        this.wdiscount = false;
        this.shipping_cost = 0;
        this.ean = "";
        this.weight = 0;
        this.width = 0;
        this.height = 0;
        this.length = 0;
        this.quantity = 0;
        this.image = new Map();
        this.images = new Array();
        this.createdAt = "";
        this.availableAt = "";
        this.supplyAt = "";
        this.statut = "wait";
        this.variations = [];
        this.values = new Map();
        this.thumb = new Map();
        this.zoom = new Map();
        this.sale = false;
        this.specialShop = false;
        this.specialWeb = false;
        this.discontinued = false;
        this.product = null;
    }
    static setByDocument(doc) {
        let declination = new Declination();
        declination.id = doc.id;
        declination.sold = doc.sold;
        declination.cost = doc.cost;
        declination.price = doc.price;
        declination.sold_price = doc.sold_price;
        declination.discount = doc.discount;
        declination.wprice = doc.wprice;
        declination.sold_wprice = doc.sold_wprice;
        declination.wdiscount = doc.wdiscount;
        declination.shipping_cost = doc.shipping_cost;
        declination.ean = doc.ean;
        declination.weight = doc.weight;
        declination.width = doc.width;
        declination.height = doc.height;
        declination.length = doc.length;
        declination.quantity = doc.quantity;
        if (doc.image == [])
            declination.image = new Map();
        else
            declination.image = doc.image;
        declination.images = doc.images;
        declination.createdAt = doc.createdAt;
        declination.availableAt = doc.availableAt;
        declination.supplyAt = doc.supplyAt;
        declination.statut = doc.statut;
        declination.variations = doc.variations;
        declination.values = doc.values;
        declination.thumb = doc.thumb;
        declination.zoom = doc.zoom;
        declination.setSale(doc.isSale);
        declination.setSpecialShop(doc.isSpecialShop);
        declination.setSpecialWeb(doc.isSpecialWeb);
        declination.setDiscontinued(doc.isDiscontinued);
        declination.product = doc.product;
        return declination;
    }
    mapToBdd(declination) {
        if (declination == null)
            return {};
        return {
            id: declination.getId(),
            product: declination.getProduct(),
            ean: declination.getEan(),
            shipping_cost: declination.getShippingCost(),
            weight: declination.getWeight(),
            height: declination.getHeight(),
            width: declination.getWidth(),
            length: declination.getLength(),
            quantity: declination.getQuantity(),
            sold: declination.getSold(),
            cost: declination.getCost(),
            price: declination.getPrice(),
            sold_price: declination.getSoldPrice(),
            discount: declination.isDiscount(),
            wprice: declination.getWPrice(),
            sold_wprice: declination.getSoldWprice,
            wdiscount: declination.isWDiscount(),
            createdAt: declination.getCreatedAt(),
            image: declination.getImage(),
            thumb: declination.getThumb(),
            zoom: declination.getZoom(),
            images: declination.getImages(),
            statut: declination.getStatut(),
            variations: declination.getVariations(),
            values: declination.getVariationsValues(),
            discontinued: declination.isDiscontinued(),
        };
    }
    getId() {
        return this.id;
    }
    setId(id) {
        this.id = id;
    }
    getProduct() {
        return this.product;
    }
    setProduct(product) {
        this.product = product;
    }
    getSold() {
        return this.sold;
    }
    setSold(sold) {
        this.sold = sold;
    }
    getCost() {
        return this.cost;
    }
    setCost(cost) {
        this.cost = cost;
    }
    getPrice() {
        return this.price;
    }
    setPrice(price) {
        this.price = price;
    }
    getSoldPrice() {
        return this.sold_price;
    }
    setSoldPrice(price) {
        this.sold_price = price;
    }
    isDiscount() {
        return this.discount;
    }
    setDiscount(discount) {
        this.discount = discount;
    }
    getWPrice() {
        return this.wprice;
    }
    setWPrice(price) {
        this.wprice = price;
    }
    getSoldWprice() {
        return this.sold_wprice;
    }
    setSoldWPrice(price) {
        this.sold_wprice = price;
    }
    isWDiscount() {
        return this.wdiscount;
    }
    setWDiscount(discount) {
        this.wdiscount = discount;
    }
    getShippingCost() {
        return this.shipping_cost;
    }
    setShippingCost(cost) {
        this.shipping_cost = cost;
    }
    getEan() {
        return this.ean;
    }
    setEan(ean) {
        this.ean = ean;
    }
    getWeight() {
        return this.weight;
    }
    setWeight(weight) {
        this.weight = weight;
    }
    getWidth() {
        return this.width;
    }
    setWidth(width) {
        this.width = width;
    }
    getHeight() {
        return this.height;
    }
    setHeight(height) {
        this.height = height;
    }
    getLength() {
        return this.length;
    }
    setLength(length) {
        this.length = length;
    }
    getQuantity() {
        return this.quantity;
    }
    setQuantity(quantity) {
        this.quantity = quantity;
    }
    getImage() {
        return this.image;
    }
    setImage(image) {
        this.image = image;
    }
    getThumb() {
        return this.thumb;
    }
    setThumb(image) {
        this.thumb = image;
    }
    getZoom() {
        return this.zoom;
    }
    setZoom(image) {
        this.zoom = image;
    }
    getImages() {
        return this.images;
    }
    setImages(images) {
        this.images = images;
    }
    getCreatedAt() {
        return this.createdAt;
    }
    setCreatedAt(date) {
        this.createdAt = date;
    }
    getAvailableAt() {
        return this.availableAt;
    }
    setAvailableAt(date) {
        this.availableAt = date;
    }
    getSupplyAt() {
        return this.supplyAt;
    }
    setSupplyAt(date) {
        this.supplyAt = date;
    }
    getStatut() {
        return this.statut;
    }
    setStatut(statut) {
        this.statut = statut;
    }
    getVariations() {
        return this.variations;
    }
    setVariations(variations) {
        this.variations = variations;
    }
    getVariationsValues() {
        return this.values;
    }
    setVariationsValues(values) {
        this.values = values;
    }
    isSpecialShop() {
        return this.specialShop;
    }
    setSpecialShop(is) {
        this.specialShop = is;
    }
    isSpecialWeb() {
        return this.specialWeb;
    }
    setSpecialWeb(is) {
        this.specialWeb = is;
    }
    isSale() {
        return this.sale;
    }
    setSale(is) {
        this.sale = is;
    }
    isDiscontinued() {
        return this.discount;
    }
    setDiscontinued(is) {
        this.discontinued = is;
    }
}

class Variation {
    constructor() {
        this.values = []; // valeurs ou valeur
        this.id = "";
        this.name = "";
        this.description = "";
        this.type = "";
        this.typeValue = "";
        this.nameValue = "";
        this.multiple = false;
        this.withValue = "";
        this.withCategory = false;
        this.values = [];
        this.display = {};
    }
    static setByDocument(doc) {
        let variation = new Variation();
        variation.setId(doc.id);
        variation.setName(doc.name);
        variation.setDescription(doc.description);
        variation.setType(doc.type);
        variation.setTypeValue(doc.typeValue);
        variation.setNameValue(doc.nameValue);
        variation.setMultiple(doc.multiple);
        variation.setWithValue(doc.withValue);
        variation.setWithCategory(doc.withCategory);
        variation.setValues(doc.values);
        variation.setDisplay(doc.display);
        return variation;
    }
    static mapToBdd(variation) {
        if (variation == null)
            return {};
        return {
            id: variation.id,
            name: variation.name,
            description: variation.description,
            type: variation.type,
            typeValue: variation.typeValue,
            nameValue: variation.nameValue,
            multiple: variation.multiple,
            withCategory: variation.withCategory,
            withValue: variation.withValue,
            values: variation.values,
            display: variation.display,
        };
    }
    getId() {
        return this.id;
    }
    setId(id) {
        this.id = id;
    }
    getName() {
        return this.name;
    }
    setName(name) {
        this.name = name;
    }
    getDescription() {
        return this.description;
    }
    setDescription(description) {
        this.description = description;
    }
    getType() {
        return this.type;
    }
    setType(type) {
        this.type = type;
    }
    getTypeValue() {
        return this.typeValue;
    }
    setTypeValue(type) {
        this.typeValue = type;
    }
    getNameValue() {
        return this.nameValue;
    }
    setNameValue(name) {
        this.nameValue = name;
    }
    getMultiple() {
        return this.multiple;
    }
    setMultiple(multiple) {
        this.multiple = multiple;
    }
    getWithCategory() {
        return this.withCategory;
    }
    setWithCategory(withCategory) {
        this.withCategory = withCategory;
    }
    getWithValue() {
        return this.withValue;
    }
    setWithValue(withValue) {
        this.withValue = withValue;
    }
    hasValue(value) {
        return this.values.includes(value);
    }
    getValues() {
        return this.values;
    }
    setValues(values) {
        this.values = values;
    }
    addValue(value) {
        if (this.hasValue(value))
            return false;
        this.values.push(value);
        return true;
    }
    getDisplay() {
        return this.display;
    }
    setDisplay(display) {
        this.display = display;
    }
}

class Maker {
    constructor() {
        this.id = "";
        this.statut = "";
        this.name = "";
        this.address = "";
        this.codePostal = 0;
        this.city = "";
        this.country = "";
        this.phone = 0;
        this.mail = "";
        this.description = "";
        this.image = null;
        this.thumb = null;
        this.nbProducts = 0;
        this.products = [];
        this.delay = 0;
        //this.restocks = [];
    }
    static setByDocument(doc) {
        let maker = new Maker();
        maker.setId(doc.id);
        maker.setStatut(doc.statut);
        maker.setName(doc.name);
        maker.setAddress(doc.address);
        maker.setCodePostal(doc.codePostal);
        maker.setCity(doc.city);
        maker.setCountry(doc.country);
        maker.setPhone(doc.phone);
        maker.setMail(doc.mail);
        maker.setDescription(doc.description);
        maker.setThumb(doc.thumb);
        maker.setImage(doc.image);
        maker.setNbProduct(doc.nbProducts);
        if (doc.products != null)
            maker.setProducts(doc.products);
        maker.setDelay(doc.delay);
        //this.restocks = doc.restocks;
        return maker;
    }
    static mapToBdd(maker) {
        if (maker == null)
            return {};
        return {
            id: maker.getId(),
            statut: maker.getStatut(),
            name: maker.getName(),
            address: maker.getAddress(),
            city: maker.getCity(),
            country: maker.getCountry(),
            delay: maker.getDelay(),
            phone: maker.getPhone(),
            mail: maker.getMail(),
            description: maker.getDescription(),
            image: maker.getImage(),
            thumb: maker.getThumb()
        };
    }
    getId() {
        return this.id;
    }
    setId(id) {
        this.id = id;
    }
    getName() {
        return this.name;
    }
    setName(name) {
        if (name == undefined)
            name = "";
        this.name = name;
    }
    getDescription() {
        return this.description;
    }
    setDescription(description) {
        if (description == undefined)
            description = "";
        this.description = description;
    }
    getStatut() {
        return this.statut;
    }
    setStatut(statut) {
        if (statut == undefined)
            statut = "";
        this.statut = statut;
    }
    getAddress() {
        return this.address;
    }
    setAddress(address) {
        if (address == undefined)
            address = "";
        this.address = address;
    }
    getCodePostal() {
        return this.codePostal;
    }
    setCodePostal(code) {
        if (code == undefined)
            code = 0;
        this.codePostal = code;
    }
    getCity() {
        return this.city;
    }
    setCity(city) {
        if (city == undefined)
            city = "";
        this.city = city;
    }
    getCountry() {
        return this.country;
    }
    setCountry(country) {
        if (country == undefined)
            country = "";
        this.country = country;
    }
    getPhone() {
        return this.phone;
    }
    setPhone(phone) {
        if (phone == undefined)
            phone = 0;
        this.phone = phone;
    }
    getMail() {
        return this.mail;
    }
    setMail(mail) {
        if (mail == undefined)
            mail = "";
        this.mail = mail;
    }
    getThumb() {
        return this.thumb;
    }
    setThumb(thumb) {
        if (thumb == undefined)
            thumb = null;
        this.thumb = thumb;
    }
    getImage() {
        return this.image;
    }
    setImage(image) {
        if (image == undefined)
            image = null;
        this.image = image;
    }
    getDelay() {
        return this.delay;
    }
    setDelay(delay) {
        if (delay == undefined)
            delay = 0;
        this.delay = delay;
    }
    getNbProduct() {
        return this.nbProducts;
    }
    setNbProduct(number) {
        this.nbProducts = number;
    }
    hasProduct(product) {
        return this.products.includes(product);
    }
    getProducts() {
        return this.products;
    }
    setProducts(products) {
        this.products = products;
        this.setNbProduct(this.products.length);
    }
    addProduct(product) {
        if (this.hasProduct(product))
            return false;
        this.products.push(product);
        this.setNbProduct(this.products.length);
        return true;
    }
    removeProduct(product) {
        if (!this.hasProduct(product))
            return false;
        this.products.splice(this.products.indexOf(product), 1);
        this.setNbProduct(this.products.length);
        return true;
    }
}

class CategoryDaoService {
    constructor(afStore, logger) {
        this.afStore = afStore;
        this.logger = logger;
        this.categoriesObs = new BehaviorSubject(null);
        this.categoriesIdObs = new BehaviorSubject(null);
        this.categoriesSubscription = this.afStore.collection("categories").valueChanges()
            .pipe(map(categories => categories.map(category => Category.setByDocument(category))))
            .subscribe(categories => {
            this.logger.object(CategoryDaoService.name, categories);
            let categoriesId = new Map();
            for (let cat of categories)
                categoriesId.set(cat.getId(), cat);
            this.categoriesObs.next(categories);
            this.categoriesIdObs.next(categoriesId);
        });
    }
    getCategoriesObs() {
        return this.categoriesObs;
    }
    getCategoriesIdObs() {
        return this.categoriesIdObs;
    }
    updateChildren(category) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.afStore.collection("categories").doc(category.getId()).update({ children: category.getChildren() }).then(() => {
                this.logger.message(CategoryDaoService.name + " - updateChildren", "Children updated");
                return true;
            }).catch(err => {
                this.logger.object(CategoryDaoService.name + " - updateChildren", err, "err");
                return false;
            });
        });
    }
    setCategory(category) {
        return __awaiter(this, void 0, void 0, function* () {
            if (category.getId() != "")
                return yield this.updateCategory(category);
            else
                return yield this.createCategory(category);
        });
    }
    updateCategory(category) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.afStore.collection("categories").doc(category.getId()).update(Category.mapToBdd(category))
                .then(() => {
                if (category.getParent()) {
                    const cats = this.categoriesIdObs.getValue();
                    if (cats) {
                        let cat = cats.get(category.getParent());
                        if (cat) {
                            if (cat.addChild(category.getId()))
                                this.updateChildren(cat);
                        }
                    }
                }
                return category;
            }).catch(err => {
                this.logger.message(CategoryDaoService.name, "Update category error", "error");
                this.logger.object(CategoryDaoService.name, err, "error");
                return null;
            });
        });
    }
    createCategory(category) {
        return __awaiter(this, void 0, void 0, function* () {
            const id = this.afStore.createId();
            category.setId(id);
            return this.afStore.collection("categories").doc(id).set(Category.mapToBdd(category)).then(() => __awaiter(this, void 0, void 0, function* () {
                if (category.getParent()) {
                    const cats = this.categoriesIdObs.getValue();
                    if (cats) {
                        let cat = cats.get(category.getParent());
                        if (cat) {
                            if (cat.addChild(id))
                                this.updateChildren(cat);
                        }
                    }
                }
                return category;
            })).catch(err => {
                this.logger.message(CategoryDaoService.name + " - createCategory", "Category creation error", "error");
                this.logger.object(CategoryDaoService.name + " - createCategory", err, "errror");
                return null;
            });
        });
    }
    haveProducts(categoryId) {
        return this.afStore.collection("categories").doc(categoryId).collection("products").ref.get().then((products) => {
            if (products.empty)
                return false;
            else
                return true;
        });
    }
    deleteCategory(categoryId) {
        return new Promise(resolve => {
            let cats = this.categoriesIdObs.getValue();
            let cat;
            if (cats) {
                cat = cats.get(categoryId);
                if (cat) {
                    if (cat.getChildren().length == 0 || cat.getNbProducts() > 0 || this.haveProducts(categoryId))
                        resolve(false);
                }
                else
                    resolve(false);
            }
            else
                resolve(false);
            this.afStore.collection("categories").doc(categoryId).delete().then(() => __awaiter(this, void 0, void 0, function* () {
                /*if( cat ){
                  if ( cat.getImage() )
                    this.fileService.deleteFile(category.image.data);
                  
                }
                if ( cat.getImage() ){
                  this.fileService.deleteFile(category.image.data);
                }
                if(category.thumb){
                  this.fileService.deleteFile(category.thumb.data);
                }
                if(category.parent){
                  var child = category.parent.children;
                  var index = child.indexOf(category);
                  child.splice(index,1);
                  category.parent.children = child;
                  await this.updateCategory(category.parent);
                  this.logger.message(CategoryBddService.name,"delete ok","debug");*/
                resolve(true);
            })).catch(err => {
                this.logger.message(CategoryDaoService.name, "delete category nok ", "error");
                this.logger.object(CategoryDaoService.name, err, "error");
                resolve(false);
            });
        });
    }
    productExist(categoryId, productId) {
        let ids = this.categoriesIdObs.getValue();
        let cat;
        if (ids)
            cat = ids.get(categoryId);
        if (cat)
            return cat.getProducts().includes(productId);
        return false;
    }
}
CategoryDaoService.ɵprov = i0.ɵɵdefineInjectable({ factory: function CategoryDaoService_Factory() { return new CategoryDaoService(i0.ɵɵinject(i1.AngularFirestore), i0.ɵɵinject(i2.LoggerService)); }, token: CategoryDaoService, providedIn: "root" });
CategoryDaoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
CategoryDaoService.ctorParameters = () => [
    { type: AngularFirestore },
    { type: LoggerService }
];

class CategoryService {
    constructor(dao) {
        this.dao = dao;
    }
    getCategoriesObs() {
        return this.dao.getCategoriesObs();
    }
    getCategoriesIdObs() {
        return this.dao.getCategoriesIdObs();
    }
    setCategory(category) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.setCategory(category);
        });
    }
    createCategory(category) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.createCategory(category);
        });
    }
    updateCategory(category) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.updateCategory(category);
        });
    }
    deleteCategory(categoryId) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.deleteCategory(categoryId);
        });
    }
    updateChildren(category) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.updateChildren(category);
        });
    }
}
CategoryService.ɵprov = i0.ɵɵdefineInjectable({ factory: function CategoryService_Factory() { return new CategoryService(i0.ɵɵinject(CategoryDaoService)); }, token: CategoryService, providedIn: "root" });
CategoryService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
CategoryService.ctorParameters = () => [
    { type: CategoryDaoService }
];

class FeatureDaoService {
    constructor(afStore, logger, displayer) {
        this.afStore = afStore;
        this.logger = logger;
        this.displayer = displayer;
        this.featuresObs = new BehaviorSubject(null);
        this.featuresIdObs = new BehaviorSubject(null);
        this.featuresSubscription = this.afStore.collection("features").valueChanges()
            .pipe(map(features => features.map(feature => Feature.setByDocument(feature))))
            .subscribe(features => {
            this.logger.object(FeatureDaoService.name, features);
            let featuresId = new Map();
            for (let feat of features)
                featuresId.set(feat.getId(), feat);
            this.featuresObs.next(features);
            this.featuresIdObs.next(featuresId);
        });
    }
    getFeaturesObs() {
        return this.featuresObs;
    }
    getFeaturesIdObs() {
        return this.featuresIdObs;
    }
    setFeature(feature, display) {
        return __awaiter(this, void 0, void 0, function* () {
            if (feature.getId() != "")
                return yield this.updateFeature(feature, display);
            else
                return yield this.createFeature(feature, display);
        });
    }
    createFeature(feature, display) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.displayer.presentLoader();
            const id = this.afStore.createId();
            feature.setId(id);
            return this.afStore.collection("features").doc(id).set(Feature.mapToBdd(feature)).then(() => __awaiter(this, void 0, void 0, function* () {
                yield this.displayer.dismissLoader();
                if (display)
                    yield this.displayer.presentAlert("Création caractéristique", "Enregistrement réussi", "Bien joué, votre caractéristique a bien été créée.");
                return feature;
            })).catch((err) => __awaiter(this, void 0, void 0, function* () {
                this.logger.message(FeatureDaoService.name, "create feature nok ", "error");
                this.logger.object(FeatureDaoService.name, err, "error");
                yield this.displayer.dismissLoader();
                if (display)
                    yield this.displayer.presentAlert("Création caractéristique", "Echec de l'enregistrement", "Oups, une erreur est survenue, votre caractéristique n'a pas été créée.");
                return null;
            }));
        });
    }
    updateFeature(feature, display) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.displayer.presentLoader();
            return this.afStore.collection("features").doc(feature.getId()).update(Feature.mapToBdd(feature)).then(() => __awaiter(this, void 0, void 0, function* () {
                yield this.displayer.dismissLoader();
                if (display)
                    yield this.displayer.presentAlert("Mise à jour caractéristique", "Enregistrement réussi", "Bien joué, votre caractéristique a bien été mise à jour.");
                return feature;
            })).catch((err) => __awaiter(this, void 0, void 0, function* () {
                this.logger.message(FeatureDaoService.name, "update feature nok ", "error");
                this.logger.object(FeatureDaoService.name, err, "error");
                yield this.displayer.dismissLoader();
                if (display)
                    yield this.displayer.presentAlert("Mise à jour caractéristique", "Echec de l'enregistrement", "Oups, une erreur est survenue, votre caractéristique n'a pas été mise à jour.");
                return null;
            }));
        });
    }
}
FeatureDaoService.ɵprov = i0.ɵɵdefineInjectable({ factory: function FeatureDaoService_Factory() { return new FeatureDaoService(i0.ɵɵinject(i1.AngularFirestore), i0.ɵɵinject(i2.LoggerService), i0.ɵɵinject(i2.DisplayerService)); }, token: FeatureDaoService, providedIn: "root" });
FeatureDaoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
FeatureDaoService.ctorParameters = () => [
    { type: AngularFirestore },
    { type: LoggerService },
    { type: DisplayerService }
];

class FeatureService {
    constructor(dao, displayer) {
        this.dao = dao;
        this.displayer = displayer;
    }
    getFeaturesObs() {
        return this.dao.getFeaturesObs();
    }
    getFeaturesIdObs() {
        return this.dao.getFeaturesIdObs();
    }
    setFeature(feature, display = true) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.setFeature(feature, display);
        });
    }
    createFeature(feature, display = true) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.createFeature(feature, display);
        });
    }
    updateFeature(feature, display = true) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.updateFeature(feature, display);
        });
    }
    addFeatureValue(feature) {
        return new Promise((resolve) => {
            switch (feature.getType()) {
                case "array":
                case "string":
                case "number":
                    this.displayer.presentValueAlert("Ajout " + feature.getName(), "", feature.getNameValue(), feature.getTypeValue(), "Entrez une valeur de type " + feature.getTypeValue()).then((value) => {
                        if (value) {
                            feature.addValue(value);
                            resolve(value);
                        }
                        else
                            resolve(null);
                    });
                    break;
                case "map":
                    if (feature.getTypeValue()[1] == "file") {
                        this.displayer.presentValueAlert("Ajout " + feature.getName(), "", feature.getNameValue()[0], feature.getTypeValue()[0], "Entrez une valeur de type " + feature.getTypeValue()[0], true).then((value) => {
                            if (value[feature.getNameValue()[0]]) {
                                feature.addValue(value);
                                resolve(value);
                            }
                            else
                                resolve(null);
                        });
                    }
                    else {
                        this.displayer.presentMapAlert("Ajout " + feature.getName(), "", feature.getNameValue(), feature.getTypeValue()).then((values) => {
                            if (values[feature.getNameValue()[0]] && values[feature.getNameValue()[1]]) {
                                feature.addValue(values);
                                resolve(values);
                            }
                            else
                                resolve(null);
                        });
                    }
                    break;
                default:
                    resolve(null);
            }
        });
    }
}
FeatureService.ɵprov = i0.ɵɵdefineInjectable({ factory: function FeatureService_Factory() { return new FeatureService(i0.ɵɵinject(FeatureDaoService), i0.ɵɵinject(i2.DisplayerService)); }, token: FeatureService, providedIn: "root" });
FeatureService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
FeatureService.ctorParameters = () => [
    { type: FeatureDaoService },
    { type: DisplayerService }
];

class VariationDaoService {
    constructor(afStore, logger) {
        this.afStore = afStore;
        this.logger = logger;
        this.variationsObs = new BehaviorSubject(null);
        this.variationsIdObs = new BehaviorSubject(null);
        this.variationsSubscription = this.afStore.collection("variations").valueChanges()
            .pipe(map(variations => variations.map(variation => Variation.setByDocument(variation))))
            .subscribe(variations => {
            this.logger.object(VariationDaoService.name, variations);
            let variationsId = new Map();
            for (let feat of variations)
                variationsId.set(feat.getId(), feat);
            this.variationsObs.next(variations);
            this.variationsIdObs.next(variationsId);
        });
    }
    getVariationsObs() {
        return this.variationsObs;
    }
    getVariationsIdObs() {
        return this.variationsIdObs;
    }
    setVariation(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            if (variation.getId() != "")
                return yield this.updateVariation(variation);
            else
                return yield this.createVariation(variation);
        });
    }
    createVariation(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            const id = this.afStore.createId();
            variation.setId(id);
            return this.afStore.collection("variations").doc(variation.getId()).set(Variation.mapToBdd(variation)).then(() => {
                return variation;
            });
        });
    }
    updateVariation(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.afStore.collection("variations").doc(variation.getId()).update(Variation.mapToBdd(variation)).then(() => {
                return variation;
            });
        });
    }
}
VariationDaoService.ɵprov = i0.ɵɵdefineInjectable({ factory: function VariationDaoService_Factory() { return new VariationDaoService(i0.ɵɵinject(i1.AngularFirestore), i0.ɵɵinject(i2.LoggerService)); }, token: VariationDaoService, providedIn: "root" });
VariationDaoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
VariationDaoService.ctorParameters = () => [
    { type: AngularFirestore },
    { type: LoggerService }
];

class VariationService {
    constructor(dao, displayer) {
        this.dao = dao;
        this.displayer = displayer;
    }
    getVariationsObs() {
        return this.dao.getVariationsObs();
    }
    getVariationsIdObs() {
        return this.dao.getVariationsIdObs();
    }
    setVariation(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.setVariation(variation);
        });
    }
    createVariation(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.createVariation(variation);
        });
    }
    updateVariation(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.dao.updateVariation(variation);
        });
    }
    addVariationValue(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve) => {
                switch (variation.getType()) {
                    case "array":
                    case "string":
                    case "number":
                        this.displayer.presentValueAlert("Ajout " + variation.getName(), "", variation.getNameValue(), variation.getTypeValue(), "Entrez une valeur de type " + variation.getTypeValue()).then(value => {
                            console.log(value);
                            if (variation.getValues().indexOf(value) > -1)
                                this.displayer.presentAlert("Erreur", variation.getNameValue() + " déjà utilisée", "Attention, cette valeur est déjà utilisée.");
                            else if (value) {
                                variation.addValue(value);
                                resolve(true);
                            }
                            else
                                resolve(false);
                        });
                        break;
                    case "map":
                        console.log("map");
                        if (variation.getTypeValue()[1] == "file") {
                            console.log("file");
                            this.displayer.presentValueAlert("Ajout " + variation.getName(), "", variation.getNameValue()[0], variation.getTypeValue()[0], "Entrez une valeur de type " + variation.getTypeValue()[0], true).then(value => {
                                if (value[variation.getNameValue()[0]]) {
                                    variation.addValue(value);
                                    console.log("variation", variation);
                                    resolve(true);
                                }
                                else
                                    resolve(false);
                            });
                        }
                        else {
                            this.displayer.presentMapAlert("Ajout " + variation.getName(), "", variation.getNameValue(), variation.getTypeValue()).then(values => {
                                console.log(values);
                                if (values[variation.getNameValue()[0]] && values[variation.getNameValue()[1]]) {
                                    console.log(values[variation.getNameValue()[0]]);
                                    console.log(values[variation.getNameValue()[1]]);
                                    variation.addValue(values);
                                    resolve(true);
                                }
                                else
                                    resolve(false);
                            });
                        }
                        break;
                    default:
                        resolve(false);
                }
            });
        });
    }
}
VariationService.ɵprov = i0.ɵɵdefineInjectable({ factory: function VariationService_Factory() { return new VariationService(i0.ɵɵinject(VariationDaoService), i0.ɵɵinject(i2.DisplayerService)); }, token: VariationService, providedIn: "root" });
VariationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
VariationService.ctorParameters = () => [
    { type: VariationDaoService },
    { type: DisplayerService }
];

class MakerDaoService {
    constructor(afStore, logger, filesService, displayer) {
        this.afStore = afStore;
        this.logger = logger;
        this.filesService = filesService;
        this.displayer = displayer;
        this.makersObs = new BehaviorSubject(null);
        this.makersIdObs = new BehaviorSubject(null);
        this.makersSubscription = this.afStore.collection("manufacturers").valueChanges()
            .pipe(map(makers => makers.map(maker => Maker.setByDocument(maker))))
            .subscribe(makers => {
            this.logger.object(MakerDaoService.name, makers);
            let makersId = new Map();
            for (let maker of makers)
                makersId.set(maker.getId(), maker);
            this.makersObs.next(makers);
            this.makersIdObs.next(makersId);
        });
    }
    getMakersObs() {
        return this.makersObs;
    }
    getMakersIdObs() {
        return this.makersIdObs;
    }
    setMaker(maker, display = true) {
        return __awaiter(this, void 0, void 0, function* () {
            if (maker.getId() != "")
                return yield this.updateMaker(maker, display);
            else
                return yield this.createMaker(maker, display);
        });
    }
    createMaker(maker, display = true) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.displayer.presentLoader();
            const id = this.afStore.createId();
            maker.setId(id);
            maker = yield this.setImage(maker);
            return this.afStore.collection("manufacturers").doc(id).set(Maker.mapToBdd(maker)).then(() => __awaiter(this, void 0, void 0, function* () {
                yield this.displayer.dismissLoader();
                if (display)
                    this.displayer.presentAlert("Création fournisseur", "Enregistrement réussi", "Bien joué, votre fournisseur a bien été créé.");
                return true;
            })).catch((err) => __awaiter(this, void 0, void 0, function* () {
                this.logger.message(MakerDaoService.name, "create maker nok ", "error");
                this.logger.object(MakerDaoService.name, err, "error");
                yield this.displayer.dismissLoader();
                if (display)
                    this.displayer.presentAlert("Création fournisseur", "Echec de l'enregistrement", "Oups, une erreur est survenue, votre fournisseur n'a pas été créé.");
                return false;
            }));
        });
    }
    updateMaker(maker, display = true) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.displayer.presentLoader();
            maker = yield this.setImage(maker);
            return this.afStore.collection("manufacturers").doc(maker.getId()).update(Maker.mapToBdd(maker)).then(() => __awaiter(this, void 0, void 0, function* () {
                yield this.displayer.dismissLoader();
                if (display)
                    this.displayer.presentAlert("Mise à jour fournisseur", "Enregistrement réussi", "Bien joué, votre fournisseur a bien été mis à jour.");
                return true;
            })).catch((err) => __awaiter(this, void 0, void 0, function* () {
                this.logger.message(MakerDaoService.name, "update maker nok ", "error");
                this.logger.object(MakerDaoService.name, err, "error");
                yield this.displayer.dismissLoader();
                if (display)
                    this.displayer.presentAlert("Mise à jour fournisseur", "Echec de l'enregistrement", "Oups, une erreur est survenue, votre fournisseur n'a pas été mis à jour.");
                return false;
            }));
        });
    }
    setImage(maker) {
        return __awaiter(this, void 0, void 0, function* () {
            let thumb = maker.getThumb();
            let image = maker.getImage();
            if (image != null && image.data != "" && image.data.substring(0, 4) == "data") {
                thumb = { data: "", extension: "", name: "" };
                thumb.name = image.name;
                thumb.extension = image.extension;
                thumb.data = yield this.filesService.resizeImage(image.data, image.extension);
                image.data = yield this.filesService.resizeImage(image.data, image.extension, 1000, 1000);
                maker.setThumb(thumb);
                maker.setImage(image);
            }
            return maker;
        });
    }
}
MakerDaoService.ɵprov = i0.ɵɵdefineInjectable({ factory: function MakerDaoService_Factory() { return new MakerDaoService(i0.ɵɵinject(i1.AngularFirestore), i0.ɵɵinject(i2.LoggerService), i0.ɵɵinject(i3.FileService), i0.ɵɵinject(i2.DisplayerService)); }, token: MakerDaoService, providedIn: "root" });
MakerDaoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
MakerDaoService.ctorParameters = () => [
    { type: AngularFirestore },
    { type: LoggerService },
    { type: FileService },
    { type: DisplayerService }
];

class MakerService {
    constructor(dao) {
        this.dao = dao;
    }
    getMakersObs() {
        return this.dao.getMakersObs();
    }
    getMakersIdObs() {
        return this.dao.getMakersIdObs();
    }
    setMaker(maker) {
        return this.dao.setMaker(maker);
    }
    createMaker(maker) {
        return this.dao.createMaker(maker);
    }
    updateMaker(maker) {
        return this.dao.updateMaker(maker);
    }
}
MakerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function MakerService_Factory() { return new MakerService(i0.ɵɵinject(MakerDaoService)); }, token: MakerService, providedIn: "root" });
MakerService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
MakerService.ctorParameters = () => [
    { type: MakerDaoService }
];

class ProductDaoService {
    constructor(afStore, logger) {
        this.afStore = afStore;
        this.logger = logger;
        this.productsObs = new BehaviorSubject(null);
        this.productsIdObs = new BehaviorSubject(null);
        this.productsEanObs = new BehaviorSubject(null);
        this.productsCatObs = new BehaviorSubject(null);
        this.afStore.collection("products").valueChanges().
            pipe(map(products => products.map(product => Product.setByDocument(product))))
            .subscribe(products => {
            this.logger.object(ProductDaoService.name, products);
            let productsId = new Map();
            let productsEan = new Map();
            let productsCat = new Map();
            for (let product of products) {
                productsId.set(product.getId(), product);
                let eanProds = productsEan.get(product.getId());
                if (!eanProds)
                    eanProds = new Array();
                eanProds.push(product);
                productsEan.set(product.getId(), eanProds);
                let cats = product.getCategories();
                for (let cat of cats) {
                    let catProds = productsCat.get(cat);
                    if (!catProds)
                        catProds = new Array();
                    catProds.push(product);
                    productsCat.set(product.getId(), catProds);
                }
            }
            this.productsObs.next(products);
            this.productsIdObs.next(productsId);
            this.productsEanObs.next(productsEan);
            this.productsCatObs.next(productsCat);
        });
    }
    ;
    getProductsObs() {
        return this.productsObs;
    }
    getProductsByIdObs() {
        return this.productsIdObs;
    }
    getProductsByEanObs() {
        return this.productsEanObs;
    }
    getProductsByCatObs() {
        return this.productsCatObs;
    }
}
ProductDaoService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ProductDaoService_Factory() { return new ProductDaoService(i0.ɵɵinject(i1.AngularFirestore), i0.ɵɵinject(i2.LoggerService)); }, token: ProductDaoService, providedIn: "root" });
ProductDaoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
ProductDaoService.ctorParameters = () => [
    { type: AngularFirestore },
    { type: LoggerService }
];

class ProductService {
    constructor(dao) {
        this.dao = dao;
    }
    getProductsObs() {
        return this.dao.getProductsObs();
    }
    getProductsByIdObs() {
        return this.dao.getProductsByIdObs();
    }
    getProductsByEanObs() {
        return this.dao.getProductsByEanObs();
    }
    getProductsByCatObs() {
        return this.dao.getProductsByCatObs();
    }
}
ProductService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ProductService_Factory() { return new ProductService(i0.ɵɵinject(ProductDaoService)); }, token: ProductService, providedIn: "root" });
ProductService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
ProductService.ctorParameters = () => [
    { type: ProductDaoService }
];

class DeclinationDaoService {
    constructor(afStore, logger) {
        this.afStore = afStore;
        this.logger = logger;
        this.combinationsObs = new BehaviorSubject(null);
        this.combinationsIdObs = new BehaviorSubject(null);
        this.combinationsEanObs = new BehaviorSubject(null);
        this.combinationsProdObs = new BehaviorSubject(null);
        this.afStore.collection("declinations").valueChanges().
            pipe(map(declinations => declinations.map(declination => Declination.setByDocument(declination))))
            .subscribe(declinations => {
            this.logger.object(DeclinationDaoService.name, declinations);
            let declinationsId = new Map();
            let declinationsEan = new Map();
            let declinationsProd = new Map();
            for (let declination of declinations) {
                declinationsId.set(declination.getId(), declination);
                let eanDecls = declinationsEan.get(declination.getId());
                if (!eanDecls)
                    eanDecls = new Array();
                eanDecls.push(declination);
                declinationsEan.set(declination.getId(), eanDecls);
                let prodDecls = declinationsProd.get(declination.getId());
                if (!prodDecls)
                    prodDecls = new Array();
                prodDecls.push(declination);
                declinationsProd.set(declination.getId(), prodDecls);
            }
            this.combinationsObs.next(declinations);
            this.combinationsIdObs.next(declinationsId);
            this.combinationsEanObs.next(declinationsEan);
            this.combinationsProdObs.next(declinationsProd);
        });
    }
    getCombinationsObs() {
        return this.combinationsObs;
    }
    getCombinationsByIdObs() {
        return this.combinationsIdObs;
    }
    getCombinationsByEanObs() {
        return this.combinationsEanObs;
    }
    getCombinationsByProdObs() {
        return this.combinationsProdObs;
    }
}
DeclinationDaoService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DeclinationDaoService_Factory() { return new DeclinationDaoService(i0.ɵɵinject(i1.AngularFirestore), i0.ɵɵinject(i2.LoggerService)); }, token: DeclinationDaoService, providedIn: "root" });
DeclinationDaoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
DeclinationDaoService.ctorParameters = () => [
    { type: AngularFirestore },
    { type: LoggerService }
];

class DeclinationService {
    constructor(dao) {
        this.dao = dao;
    }
    getCombinationsObs() {
        return this.dao.getCombinationsObs();
    }
    getCombinationsByIdObs() {
        return this.dao.getCombinationsByIdObs();
    }
    getCombinationsByEanObs() {
        return this.dao.getCombinationsByEanObs();
    }
    getCombinationsByProdObs() {
        return this.dao.getCombinationsByProdObs();
    }
}
DeclinationService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DeclinationService_Factory() { return new DeclinationService(i0.ɵɵinject(DeclinationDaoService)); }, token: DeclinationService, providedIn: "root" });
DeclinationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
DeclinationService.ctorParameters = () => [
    { type: DeclinationDaoService }
];

class MakerListPanelViewComponent {
    constructor() {
        this.view = new EventEmitter();
        this.remove = new EventEmitter();
        this.edit = new EventEmitter();
        this.makerSelect = null;
        this.makers = null;
        this.makersSubscription = null;
        this.descending = true;
        this.order = 1;
        this.column = 'name';
        this.terms = "";
        this.searchColumn = "name";
    }
    ngOnInit() {
    }
    ngOnDestroy() {
        if (this.makersSubscription)
            this.makersSubscription.unsubscribe();
    }
    loadMakers(makers) {
        this.makers = makers;
    }
    addMaker() {
        this.makerSelect = new Maker();
        this.edit.emit(this.makerSelect);
    }
    removeMaker(maker) {
        this.remove.emit(maker);
    }
    editMaker(maker) {
        this.makerSelect = maker;
        this.edit.emit(maker);
    }
    selectMaker(maker) {
        this.makerSelect = maker;
        this.view.emit(maker);
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
    tracking(index, maker) {
        return maker.getId();
    }
}
MakerListPanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-maker-list-panel-view',
                template: "<div slot=\"fixed\">\n    <ion-searchbar [(ngModel)]=\"terms\" animated></ion-searchbar>\n  </div>\n  <ion-list class=\"block\" *ngIf=\"makers != null\">\n    <ion-item-sliding #slidingItem *ngFor=\"let maker of makers | sort: {property: column, order: order} | search: {property: searchColumn,terms: terms} ; trackBy:tracking\">\n      <ion-item (click)=\"selectMaker(maker)\" [ngClass]=\"{'selected':maker.getId() === makerSelect?.getId(), 'wait':maker.statut === 'wait'}\"><ion-avatar><ion-img src=\"{{maker.thumb?.data}}\"></ion-img></ion-avatar> {{maker.name}}</ion-item>\n      <ion-item-options side=\"end\">\n        <ion-button color=\"danger\" (click)=\"removeMaker(maker)\" slot=\"icon-only\">\n          <ion-icon name=\"trash-outline\"></ion-icon>\n        </ion-button>\n        <ion-button color=\"success\" icon-only >\n          <ion-icon name=\"create-outline\"></ion-icon>\n        </ion-button>\n      </ion-item-options>\n    </ion-item-sliding>\n  </ion-list>\n  \n  <ion-list class=\"block\" *ngIf=\"makers == null\">\n    <ion-item lines=\"none\">          \n      <ion-list id=\"list-cat-skelet\">\n        <ion-item lines=\"none\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n      </ion-list>\n    </ion-item>\n  </ion-list>",
                styles: ["ion-avatar{margin-right:1em}ion-list{width:100%}.wait{--background:var(--ion-color-warning)}.reject{--background:var(--ion-color-danger);color:#fff}.selected{--background:var(--ion-color-secondary)!important;background-color:var(--ion-color-secondary)!important}#list-cat-skelet ion-item{margin:0}"]
            },] }
];
MakerListPanelViewComponent.ctorParameters = () => [];
MakerListPanelViewComponent.propDecorators = {
    view: [{ type: Output }],
    remove: [{ type: Output }],
    edit: [{ type: Output }]
};

class MakerListPanelViewComponentModule {
}
MakerListPanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    MakerListPanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                providers: [],
                exports: [
                    MakerListPanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class MakerCreatePanelViewComponent {
    constructor(formBuilder, logger) {
        this.formBuilder = formBuilder;
        this.logger = logger;
        this.update = new EventEmitter();
        this.description = "";
        this.hasImage = false;
        this.image = null;
        this.statutState = false;
        this.statut = "wait";
        this.makerForm = this.formBuilder.group({
            name: '',
            address: '',
            codePostal: '',
            city: '',
            country: '',
            phone: '',
            mail: ['', [Validators.email]],
            delay: '',
        });
        this.id = "";
        this.maker = null;
    }
    ngOnInit() {
    }
    select(maker) {
        var _a;
        this.logger.object(MakerCreatePanelViewComponent.name + " - select", maker);
        if (maker) {
            this.maker = maker;
            let phone = "";
            if (maker.getPhone() != 0)
                phone = maker.getPhone();
            let cp = "";
            if (maker.getCodePostal() != 0)
                cp = maker.getCodePostal();
            this.makerForm.setValue({
                name: maker.getName(),
                address: maker.getAddress(),
                city: maker.getCity(),
                country: maker.getCountry(),
                phone: phone,
                mail: maker.getMail(),
                delay: maker.getDelay(),
                codePostal: cp
            });
            this.id = maker.getId();
            this.description = maker.getDescription();
            this.image = maker.getImage();
            if (this.image) {
                this.nameImage = this.image.fileName;
                this.extensionImage = (_a = this.image.extension) === null || _a === void 0 ? void 0 : _a.split("/")[1];
                this.typeImage = "image";
            }
            else {
                this.nameImage = undefined;
                this.extensionImage = undefined;
                this.typeImage = undefined;
            }
            this.statut = maker.getStatut();
            if (this.statut == "publish")
                this.statutState = true;
            else
                this.statutState = false;
        }
    }
    onContentChanged(content) {
        this.description = content;
    }
    onSubmitForm() {
        return __awaiter(this, void 0, void 0, function* () {
            const values = this.makerForm.value;
            if (this.maker) {
                this.maker.setName(values["name"]);
                this.maker.setStatut("wait");
                this.maker.setCodePostal(values["codePostal"]);
                this.maker.setAddress(values['address']);
                this.maker.setCity(values['city']);
                this.maker.setCountry(values['country']);
                this.maker.setPhone(values['phone']);
                this.maker.setMail(values['mail']);
                this.maker.setDelay(values['delay']);
                this.maker.setDescription(this.description);
                if (this.image)
                    this.maker.setImage(this.image);
                this.maker.setStatut(this.statut);
                this.update.emit(this.maker);
            }
        });
    }
    imageSelected(file) {
        console.log(file);
        this.image = file;
    }
    setStatut() {
        if (this.statutState)
            this.statut = "publish";
        else
            this.statut = "reject";
    }
}
MakerCreatePanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-maker-create-panel-view',
                template: "\n<form [formGroup]=\"makerForm\" (ngSubmit)=\"onSubmitForm()\">\n    <ion-item lines=\"full\" class=\"title\"><ion-label>Informations</ion-label></ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">Id fabricant</ion-label>\n     <ion-input id=\"id\" [(ngModel)]=\"id\"  [ngModelOptions]=\"{standalone: true}\" disabled></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">Nom *</ion-label>\n     <ion-input id=\"name\" formControlName=\"name\" clearInput required></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">Adresse</ion-label>\n     <ion-input id=\"address\" formControlName=\"address\" clearInput></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">Code postal</ion-label>\n     <ion-input id=\"codePostal\" formControlName=\"codePostal\" clearInput type=\"number\"></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">Ville</ion-label>\n     <ion-input id=\"city\" formControlName=\"city\" clearInput></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">Pays *</ion-label>\n     <ion-input id=\"country\" formControlName=\"country\" clearInput required></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">T\u00E9l\u00E9phone</ion-label>\n     <ion-input id=\"phone\" formControlName=\"phone\" clearInput type=\"number\"></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">Email</ion-label>\n     <ion-input id=\"mail\" formControlName=\"mail\" clearInput type=\"email\"></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-label position=\"floating\">D\u00E9lai de livraison (en jours) *</ion-label>\n     <ion-input id=\"delay\" formControlName=\"delay\" clearInput required type=\"number\"></ion-input>\n   </ion-item>\n   <ion-item lines=\"none\" id=\"text-rich\">\n     <ctl-text-rich  id=\"description\" placeholder=\"Description d\u00E9taill\u00E9e\" [content]=\"description\" (changed)=\"onContentChanged($event)\"></ctl-text-rich>\n   </ion-item>\n   <ion-item lines=\"none\">\n     Image d'ent\u00EAte\n   </ion-item>\n   <ion-item>\n     <ctl-file-chooser type=\"['image']\" [file]=\"image\" [fileName]=\"nameImage\" [extension]=\"extensionImage\" [typeSelected]=\"typeImage\" (fileSelected)=\"imageSelected($event)\"></ctl-file-chooser>\n   </ion-item>\n   <ion-item lines=\"none\">\n     <ion-toggle [(ngModel)]=\"statutState\" [ngModelOptions]=\"{standalone: true}\" (ionChange)=\"setStatut()\"></ion-toggle>\n     <ion-label>Mise en ligne du fournisseur ?</ion-label>    \n   </ion-item>\n   <!--<ion-button type=\"submit\" [disabled]=\"makerForm.invalid\" expand=\"block\">Enregistrer</ion-button>-->\n</form>",
                styles: [".title{font-weight:700;font-size:1.2em}.title ion-label{padding:.2em 2em}ctl-text-rich,text-rich{width:100%!important}"]
            },] }
];
MakerCreatePanelViewComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: LoggerService }
];
MakerCreatePanelViewComponent.propDecorators = {
    update: [{ type: Output }]
};

class MakerCreatePanelViewComponentModule {
}
MakerCreatePanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    MakerCreatePanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                    TextRichComponentModule,
                    FileChooserComponentModule
                ],
                providers: [],
                exports: [
                    MakerCreatePanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class CategoryListPanelViewComponent {
    constructor() {
        this.view = new EventEmitter();
        this.remove = new EventEmitter();
        this.edit = new EventEmitter();
        this.loaded = new EventEmitter();
        this.categorySelect = null;
        this.categories = [];
        this.descending = true;
        this.order = 1;
        this.column = 'name';
        this.terms = "";
        this.searchColumn = "name";
    }
    ngOnInit() { }
    loadCategories(categories) {
        this.categories = categories;
    }
    removeCategory(category) {
        this.remove.emit(category);
    }
    editCategory(category) {
        this.categorySelect = category;
        this.edit.emit(category);
    }
    selectCategory(category) {
        this.categorySelect = category;
        this.view.emit(category);
    }
    tracking(index, category) {
        return category.getId();
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
}
CategoryListPanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-category-list-panel-view',
                template: "<div slot=\"fixed\">\n    <ion-searchbar [(ngModel)]=\"terms\" animated></ion-searchbar>\n  </div>\n  <ion-list *ngIf=\"categories.length != 0\">\n    <ion-item-sliding #slidingItem *ngFor=\"let category of categories | search: {property: searchColumn,terms: terms} ; trackBy:tracking\">\n      <ion-item lines=\"full\" (click)=\"selectCategory(category)\" [ngClass]=\"{'selected':category.id === categorySelect?.getId(), 'reject':category.statut === 'reject', 'wait':category.statut === 'wait'}\">\n        <span class=\"indent\" *ngFor=\"let i of [].constructor(category.getLevel())\"></span>\n        <!--<span class=\"indent\" *ngFor=\"let i of category.getLevel()|times\"></span>-->\n        <ion-avatar><ion-img src=\"{{category.thumb?.data}}\"></ion-img></ion-avatar>\n        {{category.name}}\n      </ion-item>\n      <ion-item-options side=\"end\">\n        <ion-button color=\"danger\" (click)=\"removeCategory(category)\" slot=\"icon-only\">\n          <ion-icon name=\"trash-outline\"></ion-icon>\n        </ion-button>\n        <!--<ion-button color=\"success\" (click)=\"editCategory(category)\"  slot=\"icon-only\">\n          <ion-icon name=\"create-outline\"></ion-icon>\n        </ion-button>-->\n      </ion-item-options>\n    </ion-item-sliding>\n  </ion-list>\n  \n  <ion-list class=\"block\" *ngIf=\"categories.length == 0\">\n    <ion-item lines=\"none\">          \n      <ion-list id=\"list-cat-skelet\">\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item1\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item1\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item2\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n      </ion-list>\n    </ion-item>\n  </ion-list>",
                styles: ["ion-avatar{min-width:2em;margin-right:1em}ion-list{width:100%}.wait{--background:var(--ion-color-warning)}.reject{--background:var(--ion-color-danger);color:#fff}.selected{--background:var(--ion-color-secondary)!important;background-color:var(--ion-color-secondary)!important}#list-cat-skelet ion-item,.indent{margin:0}.indent{padding:0 0 0 2em}.item0{padding:0;margin:0}.item1{margin:0;padding:0 0 0 2em}.item2{margin:0;padding:0 0 0 4em}"]
            },] }
];
CategoryListPanelViewComponent.ctorParameters = () => [];
CategoryListPanelViewComponent.propDecorators = {
    view: [{ type: Output }],
    remove: [{ type: Output }],
    edit: [{ type: Output }],
    loaded: [{ type: Output }]
};

class CategoryListPanelViewComponentModule {
}
CategoryListPanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    CategoryListPanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                providers: [],
                exports: [
                    CategoryListPanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class CategorySelectListPanelViewComponent {
    constructor() {
        this.select = new EventEmitter();
        this.type = "";
        this.descending = true;
        this.order = 1;
        this.column = 'name';
    }
    ngOnInit() {
        console.log("categories", this.categories);
    }
    loadCategories(categories) {
        console.log("loadcategories", this.categories);
        this.categories = categories;
    }
    setCategories(categories) {
        console.log("setcategorie", categories);
        if (categories) {
            this.categoriesSelect = categories;
            for (const cat of this.categoriesSelect) {
                var ind = document.getElementById(cat.getId());
                console.log(ind);
                if (ind)
                    ind.checked = true;
            }
        }
    }
    selectCategory(category) {
        if (category) {
            if (this.type == "radio") {
                this.categoriesSelect = [category];
                //this.categoriesSelect = [ category ];
            }
            else if (this.categoriesSelect.includes(category))
                this.categoriesSelect.splice(this.categoriesSelect.indexOf(category), 1);
            else
                this.categoriesSelect.push(category);
            this.select.emit(this.categoriesSelect);
        }
    }
    tracking(index, category) {
        return category.getId();
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
    checking(category) {
        return this.categoriesSelect.includes(category);
    }
}
CategorySelectListPanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-category-select-list-panel-view',
                template: "<ion-list class=\"block\" *ngIf=\"categories.length > 0\">\n    <ion-item lines=\"none\" *ngFor=\"let category of categories\">          \n      <ion-list id=\"list-cat\">\n        <ion-item lines=\"none\" class=\"item{{category.level}}\">\n          <ion-checkbox *ngIf=\"type == 'checkbox'\" slot=\"start\" id=\"{{category.id}}\" (click)=\"selectCategory(category)\"></ion-checkbox>\n          \n          <ion-radio-group *ngIf=\"type == 'radio'\" [value]=\"categoriesSelect[0]?.getId()\">\n            <ion-radio slot=\"start\" value=\"{{category.id}}\" (click)=\"selectCategory(category)\"></ion-radio>\n          </ion-radio-group>\n          \n          <ion-label>{{category.name}}</ion-label>\n        </ion-item>\n      </ion-list>\n    </ion-item>\n  </ion-list>\n  \n  <ion-list class=\"block\" *ngIf=\"categories.length == 0\">\n    <ion-item lines=\"none\">          \n      <ion-list id=\"list-cat-skelet\">\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item1\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item1\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item2\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n      </ion-list>\n    </ion-item>\n  </ion-list>",
                styles: ["ion-list{width:100%}#list-cat-label{margin-bottom:-.5em}#list-cat ion-item{margin:-1em 0}#list-cat-skelet ion-item{margin:0}.sub{padding-left:1em}.item0{padding:0;margin:0}.item1{margin:0;padding:0 0 0 2em}.item2{margin:0;padding:0 0 0 4em}"]
            },] }
];
CategorySelectListPanelViewComponent.ctorParameters = () => [];
CategorySelectListPanelViewComponent.propDecorators = {
    select: [{ type: Output }],
    type: [{ type: Input }],
    categoriesSelect: [{ type: Input }],
    categories: [{ type: Input }]
};

class CategoryListModalComponent {
    constructor(modalCtrl, navParams) {
        this.modalCtrl = modalCtrl;
        this.navParams = navParams;
        let items = this.navParams.get("items");
        this.categories = items.categories;
        this.categoriesSelect = items.parent;
        this.type = items.type;
        console.log(items);
    }
    ngOnInit() {
    }
    select(categories) {
        console.log(categories);
        this.categoriesSelect = categories;
    }
    tracking(index, category) {
        return category.getId();
    }
    dismiss() {
        this.modalCtrl.dismiss(this.categoriesSelect);
    }
    close() {
        this.modalCtrl.dismiss(null);
    }
    ionViewDidEnter() {
        console.log("did enter", this.categories);
        this.categoryList.loadCategories(this.categories);
        this.categoryList.setCategories(this.categoriesSelect);
    }
}
CategoryListModalComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-category-list-modal',
                template: "<ion-header>\n    <ion-toolbar>\n      <ion-title>\n        Choississez vos cat\u00E9gories\n      </ion-title>\n      <ion-buttons slot=\"end\">\n        <ion-button (click)=\"close()\">\n          <ion-icon slot=\"icon-only\" name=\"close\" color=\"medium\"></ion-icon>  \n        </ion-button>\n        <!-- <ion-menu-button autoHide=\"false\"></ion-menu-button> -->\n    </ion-buttons>\n    \n    </ion-toolbar>\n  </ion-header>\n  <ion-content>\n    <!--<ctl-category-list-panel-view (view)=\"select($event)\"></ctl-category-list-panel-view>-->\n    <ctl-category-select-list-panel-view #categoryList [categories]=\"categories\" [categoriesSelect]=\"categoriesSelect\" [type]=\"type\" (select)=\"select($event)\"></ctl-category-select-list-panel-view>\n    \n    <!--<ion-list *ngIf=\"categories.length != 0\">\n      <ion-item *ngFor=\"let category of categories ; trackBy:trackCategories\" class=\"item{{category.level}}\" lines=\"full\" (click)=\"select(category)\" [ngClass]=\"{'selected':category.id === categorySelect?.id}\">\n        <ion-avatar *ngIf=\"category.thumb\"><ion-img src=\"{{category.thumb?.data}}\"></ion-img></ion-avatar>\n        {{category.name}}\n      </ion-item>\n    </ion-list>-->\n\n  </ion-content>\n  <ion-footer>\n    <ion-button (click)=\"dismiss()\" expand=\"full\">Valider</ion-button>\n  </ion-footer>\n  \n  ",
                styles: [""]
            },] }
];
CategoryListModalComponent.ctorParameters = () => [
    { type: ModalController },
    { type: NavParams }
];
CategoryListModalComponent.propDecorators = {
    categoryList: [{ type: ViewChild, args: ['categoryList', { read: CategorySelectListPanelViewComponent, static: false },] }]
};

class CategoryCreatePanelViewComponent {
    constructor(formBuilder, displayer, featureService) {
        this.formBuilder = formBuilder;
        this.displayer = displayer;
        this.featureService = featureService;
        this.update = new EventEmitter();
        this.deleteChildren = new EventEmitter();
        this.categories = null;
        this.featuresId = null;
        this.featuresList = null;
        this.description = "";
        this.hasThumb = false;
        this.thumb = null;
        this.published = false;
        this.typeThumb = "";
        this.extensionThumb = "";
        this.nameThumb = "";
        this.id = "";
        this.category = null;
        this.features = [];
        // this.categories = [];
        this.children = [];
        this.parent = null;
        this.oldParent = null;
        this.categoryForm = this.formBuilder.group({
            name: ''
        });
        combineLatest([
            this.featureService.getFeaturesObs(),
            this.featureService.getFeaturesIdObs()
        ]).subscribe(([featuresList, featuresId]) => {
            if (featuresId)
                this.featuresId = featuresId;
            if (featuresList)
                this.featuresList = featuresList;
        });
    }
    ngOnInit() {
    }
    loadCategories(categories) {
        this.categories = categories;
    }
    select(category) {
        var _a, _b;
        if (category) {
            this.category = category;
            this.categoryForm.setValue({
                name: category.getName(),
            });
            this.id = category.getId();
            this.published = category.getStatut() == "publish" ? true : false;
            this.description = category.getDescription();
            this.thumb = category.getThumb();
            if (this.thumb) {
                this.nameThumb = this.thumb.fileName;
                this.extensionThumb = (_a = this.thumb.extension) === null || _a === void 0 ? void 0 : _a.split('/')[1];
                this.typeThumb = "image";
            }
            this.parent = (_b = this.categories) === null || _b === void 0 ? void 0 : _b.find(cat => { return cat.getId() == category.getParent(); });
            this.oldParent = null;
            this.children = category.getChildren();
            this.features = [];
            if (this.featuresId)
                for (let feat of category.getFeatures()) {
                    let f = this.featuresId.get(feat);
                    if (f)
                        this.features.push(f);
                }
            console.log("ici ", category);
        }
    }
    selectCat() {
        /*console.log( "cats", this.categories );
        let catsList = [];
        if ( this.categories )
          for ( let cat of this.categories ) {
            catsList.push( { type: 'radio', label: cat.getName(), value: cat.getId(), checked: ( this.category!.getParent().includes( cat.getId() ) ) } );
          }
        this.displayer.presentInputsAlert( "Un parent ?", "Cochez la catégorie parente", "Catégorie","",catsList, true ).then( async ( category ) => {
          console.log("result",category);
          if ( category != null ) {
            this.parent = this.categories?.find(cat => { return cat.getId() == category.getParent()});
          }
        })*/
        this.displayer.presentModal(CategoryListModalComponent, { categories: this.categories, parent: [this.parent], type: "radio" }).then((categories) => {
            var _a;
            console.log("cat", categories);
            if (categories && categories.length > 0) {
                if (this.parent)
                    this.oldParent = this.parent;
                this.parent = categories[0];
                (_a = this.category) === null || _a === void 0 ? void 0 : _a.setParent(categories[0].getId());
            }
        });
    }
    selectFeature() {
        if (this.featuresId && this.featuresList) {
            let feastsList = [];
            if (this.features)
                for (let feature of this.featuresList) {
                    feastsList.push({ type: 'checkbox', label: feature.getName(), value: feature, checked: (this.features.includes(feature)) });
                }
            this.displayer.presentInputsAlert("Une caractéristique ?", "Cochez les caractéristiques à utiliser avec cette catégorie", "Catégorie", "", feastsList, true).then((features) => __awaiter(this, void 0, void 0, function* () {
                var _a;
                console.log("result", features);
                if (features != null) {
                    //this.parent = this.categories?.find(cat => { return cat.getId() == category.getParent()});
                    this.features = features;
                    (_a = this.category) === null || _a === void 0 ? void 0 : _a.setFeatures(features);
                }
            }));
        }
    }
    onContentChanged(content) {
        this.description = content;
    }
    onSubmitForm() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.category) {
                const values = this.categoryForm.value;
                console.log(values['name']);
                this.category.setId(this.id);
                this.category.setName(values['name']);
                if (this.published)
                    this.category.setStatut('publish');
                this.category.setDescription(this.description);
                if (this.hasThumb)
                    this.category.setThumb(this.thumb);
                if (this.parent) {
                    this.category.setParent(this.parent.getId());
                    this.category.setLevel(this.parent.getLevel() + 1);
                }
                else
                    this.category.setLevel(0);
                this.category.setChildren(this.children);
                let feats = [];
                for (let f of this.features)
                    feats.push(f.getId());
                this.category.setFeatures(feats);
                console.log("create category", this.category);
                this.update.emit(this.category);
                if (this.oldParent)
                    this.deleteChildren.emit(this.oldParent);
            }
        });
    }
    thumbSelected(file) {
        console.log(file);
        this.hasThumb = true;
        this.thumb = file;
    }
}
CategoryCreatePanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-category-create-panel-view',
                template: "<form [formGroup]=\"categoryForm\" (ngSubmit)=\"onSubmitForm()\">\n    <ion-item lines=\"full\" class=\"title\"><ion-label>Informations</ion-label></ion-item>\n    <ion-item lines=\"none\">\n      <ion-label position=\"floating\">Id cat\u00E9gorie</ion-label>\n      <ion-input id=\"id\" [(ngModel)]=\"id\"  [ngModelOptions]=\"{standalone: true}\" disabled></ion-input>\n    </ion-item>\n    <ion-item lines=\"none\">\n      <ion-label position=\"floating\">Nom *</ion-label>\n      <ion-input id=\"name\" formControlName=\"name\" clearInput required></ion-input>\n    </ion-item>\n    <ion-item id=\"list-cat-label\" lines=\"none\">\n      Categorie parente \n      <ion-button (click)=\"selectCat()\"><ion-icon name=\"duplicate-outline\"></ion-icon></ion-button>\n    </ion-item>\n      <div class=\"category\">\n        <ion-label>{{parent?.getName()}}</ion-label>\n      </div>\n\n      <ion-item id=\"list-cat-label\" lines=\"none\">\n        Caract\u00E9ristiques\n        <ion-button (click)=\"selectFeature()\"><ion-icon name=\"list-outline\"></ion-icon></ion-button>\n      </ion-item>\n        <div class=\"category\" *ngFor=\"let feature of features\">\n          <ion-label>{{feature.name}}</ion-label>\n        </div>\n    \n    \n    <ion-item lines=\"none\" id=\"text-rich\">\n        <ctl-text-rich id=\"description\" placeholder=\"Description d\u00E9taill\u00E9e\" [content]=\"description\" (changed)=\"onContentChanged($event)\"></ctl-text-rich>\n      </ion-item>\n      <ion-item lines=\"none\">\n        Image d'ent\u00EAte\n      </ion-item>\n      <ion-item>\n        <ctl-file-chooser [ratio]=\"16/9\" type=\"['image']\" [file]=\"thumb\" [fileName]=\"nameThumb\" [extension]=\"extensionThumb\" [typeSelected]=\"typeThumb\" (fileSelected)=\"thumbSelected($event)\"></ctl-file-chooser>\n      </ion-item>\n      <ion-item [hidden]=\"id == null\">\n        <ion-toggle [(ngModel)]=\"published\" [ngModelOptions]=\"{standalone: true}\"></ion-toggle>\n        <p>Publi\u00E9 la cat\u00E9gorie</p>\n      </ion-item>\n      <!--<ion-button type=\"submit\" [disabled]=\"categoryForm.invalid\" expand=\"block\">Enregistrer</ion-button>-->\n</form>",
                styles: [".title{font-weight:700;font-size:1.2em}.title ion-label{padding:.2em 2em}.category,ctl-text-rich,text-rich{width:100%!important}.category{display:block;margin:0 0 0 2em}.category p{display:inline-block;margin:0;padding:0}.category .p1{margin-left:1em}.category .p2{margin-left:2em}"]
            },] }
];
CategoryCreatePanelViewComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: DisplayerService },
    { type: FeatureService }
];
CategoryCreatePanelViewComponent.propDecorators = {
    update: [{ type: Output }],
    deleteChildren: [{ type: Output }],
    categories: [{ type: Input }]
};

class CategoryCreatePanelViewComponentModule {
}
CategoryCreatePanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    CategoryCreatePanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                    TextRichComponentModule,
                    FileChooserComponentModule
                ],
                providers: [],
                exports: [
                    CategoryCreatePanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class CategorySelectListPanelViewComponentModule {
}
CategorySelectListPanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    CategorySelectListPanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                providers: [],
                exports: [
                    CategorySelectListPanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class CategoryListModalComponentModule {
}
CategoryListModalComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    CategoryListModalComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                    CategorySelectListPanelViewComponentModule
                ],
                providers: [],
                exports: [
                    CategoryListModalComponent
                ],
                entryComponents: [],
            },] }
];

class FeatureListPanelViewComponent {
    constructor() {
        this.view = new EventEmitter();
        this.remove = new EventEmitter();
        this.featureSelect = null;
        this.features = [];
        this.featuresSelected = [];
        this.descending = true;
        this.order = 1;
        this.column = 'order';
        this.terms = "";
        this.searchColumn = "name";
    }
    ngOnInit() {
    }
    loadFeatures(features) {
        this.features = features;
    }
    setFeatures(features) {
        this.featuresSelected = features;
    }
    removeFeature(feature) {
        this.remove.emit(feature);
    }
    selectFeature(feature) {
        this.featureSelect = feature;
        this.view.emit(feature);
    }
    tracking(index, feature) {
        return feature.getId();
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
}
FeatureListPanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-feature-list-panel-view',
                template: "<div slot=\"fixed\">\n  <ion-searchbar [(ngModel)]=\"terms\" animated></ion-searchbar>\n</div>\n<ion-list *ngIf=\"features.length != 0\">\n  <ion-item-sliding #slidingItem *ngFor=\"let feature of features | sort: {property: column, order: order} | search: {property: searchColumn,terms: terms} ; trackBy:tracking\">\n    <ion-item lines=\"full\" (click)=\"selectFeature(feature)\" [ngClass]=\"{'selected':feature.getId() === featureSelect?.getId()}\">\n      <ion-avatar><ion-img src=\"{{feature.getIcon()?.data}}\"></ion-img></ion-avatar>\n      {{feature.name}}\n    </ion-item>\n    <ion-item-options side=\"end\">\n      <ion-button color=\"danger\" (click)=\"removeFeature(feature)\" slot=\"icon-only\">\n        <ion-icon name=\"trash-outline\"></ion-icon>\n      </ion-button>\n    </ion-item-options>\n  </ion-item-sliding>\n</ion-list>\n\n<ion-list class=\"block\" *ngIf=\"features.length == 0\">\n  <ion-item lines=\"none\">          \n    <ion-list id=\"list-cat-skelet\">\n      <ion-item lines=\"none\" class=\"item0\">\n        <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n        <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n      </ion-item>\n      <ion-item lines=\"none\" class=\"item0\">\n        <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n        <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n      </ion-item>\n      <ion-item lines=\"none\" class=\"item0\">\n        <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n        <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n      </ion-item>\n      <ion-item lines=\"none\" class=\"item0\">\n        <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n        <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n      </ion-item>\n      <ion-item lines=\"none\" class=\"item0\">\n        <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n        <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n      </ion-item>\n      <ion-item lines=\"none\" class=\"item0\">\n        <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n        <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n      </ion-item>\n    </ion-list>\n  </ion-item>\n</ion-list>\n\n\n<!--<ion-list class=\"block\">\n    <ion-item lines=\"none\" *ngFor=\"let feature of features\">          \n      <ion-list id=\"list-feature\">\n        <ion-item lines=\"none\">\n          <ion-checkbox slot=\"start\" id=\"{{feature.id}}\" (click)=\"selectFeature(feature)\"></ion-checkbox>\n          <ion-label>{{feature.name}}</ion-label>\n        </ion-item>\n      </ion-list>\n    </ion-item>\n  </ion-list>-->",
                styles: ["ion-avatar{min-width:2em;margin-right:1em}ion-list{width:100%}.wait{--background:var(--ion-color-warning)}.reject{--background:var(--ion-color-danger);color:#fff}.selected{--background:var(--ion-color-secondary)!important;background-color:var(--ion-color-secondary)!important}#list-cat-skelet ion-item,.indent{margin:0}.indent{padding:0 0 0 2em}.item0{padding:0;margin:0}.item1{margin:0;padding:0 0 0 2em}.item2{margin:0;padding:0 0 0 4em}"]
            },] }
];
FeatureListPanelViewComponent.ctorParameters = () => [];
FeatureListPanelViewComponent.propDecorators = {
    view: [{ type: Output }],
    remove: [{ type: Output }]
};

class FeatureListPanelViewComponentModule {
}
FeatureListPanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FeatureListPanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                providers: [],
                exports: [
                    FeatureListPanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class FeatureCreatePanelViewComponent {
    constructor(formBuilder, displayer, featureService) {
        this.formBuilder = formBuilder;
        this.displayer = displayer;
        this.featureService = featureService;
        this.features = [];
        this.feature = null;
        this.icon = null;
        this.extensionIcon = "";
        this.nameIcon = "";
        this.id = "";
        this.displayFilter = false;
        this.filter = { display: true };
        this.display = { icon: true, label: false, separate: ":", suffix: "", type: "" };
        //public order:number = 1;
        this.isMultiple = false;
        this.withCategory = false;
        this.withValue = false;
        this.nameValue = "";
        this.typeValue = "";
        this.type = "";
        //public name:string = "";
        this.description = "";
        this.descending = true;
        this.order = 1;
        this.column = 'value';
        this.columnKey = 'key';
        this.steps = "";
        this.featureForm = this.formBuilder.group({
            name: ['', Validators.required],
            description: ['', Validators.required],
            type: ['', Validators.required],
            nameValue: ['', Validators.required],
            typeValue: ['', Validators.required],
            multiple: [false, Validators.required],
            withCategory: [false, Validators.required],
            withValue: ['', Validators.required],
            order: [1, Validators.required]
        });
    }
    ngOnInit() {
        this.steps = "infos";
        this.type = "number";
    }
    segmentChanged(panel) {
        console.log("panel", panel);
        let select = document.getElementById("selectWithValue");
        if (this.withValue) {
            if (select)
                select.disabled = false;
        }
        else if (select)
            select.disabled = true;
    }
    seeTips($event, message) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.displayer.presentMessagePopover($event, message);
        });
    }
    iconSelected(file) {
        console.log(file);
        if (file) {
            this.icon = file;
            this.extensionIcon = file.extension.split("/")[1];
            this.nameIcon = file.name;
        }
        else {
            this.icon = null;
            this.extensionIcon = "";
            this.nameIcon = "";
        }
    }
    onSubmitForm() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.feature) {
                if (this.featureForm.invalid) {
                    yield this.displayer.presentAlert("Enregistrement caractéristique", "erreur", "Les données que vous avez saisie sont erronées");
                    return;
                }
                yield this.displayer.presentLoader();
                this.display = {};
                this.display.type = this.typeValue;
                this.filter = {};
                this.filter.display = this.displayFilter;
                this.feature.setIcon(this.icon);
                this.feature.setName(this.featureForm.value.name);
                this.feature.setMultiple(this.featureForm.value.multiple);
                this.feature.setWithCategory(this.featureForm.value.withCategory);
                this.feature.setNameValue(this.featureForm.value.nameValue);
                this.feature.setOrder(this.featureForm.value.order);
                this.feature.setType(this.featureForm.value.type);
                this.feature.setDescription(this.featureForm.value.description);
                this.feature.setDisplay(this.display);
                this.feature.setFilter(this.filter);
                this.feature.setTypeValue(this.featureForm.value.typeValue);
                //this.feature.setValues( [] );
                this.featureService.setFeature(this.feature).then((result) => __awaiter(this, void 0, void 0, function* () {
                    if (result)
                        this.feature = result;
                }));
            }
        });
    }
    save() {
        console.log("save");
        //let feature:Feature = new Feature();
        //feature.setWithValue( this.withValue );
        //feature.setName( this.name );
    }
    /*loadFeatures( features :Array<Feature> ) :void {
      this.features = features;
    }*/
    select(feature) {
        var _a;
        this.feature = feature;
        console.log("feature", feature);
        if (feature) {
            this.id = feature.getId();
            this.featureForm.setValue({
                name: feature.getName(),
                description: feature.getDescription(),
                type: feature.getType(),
                nameValue: feature.getNameValue(),
                typeValue: feature.getTypeValue(),
                withCategory: feature.getWithCategory(),
                withValue: feature.getWithValue(),
                multiple: feature.getMultiple(),
                order: feature.getOrder()
            });
            this.icon = feature.getIcon();
            if (this.icon) {
                this.nameIcon = this.icon.fileName;
                this.extensionIcon = (_a = this.icon.extension) === null || _a === void 0 ? void 0 : _a.split('/')[1];
                //this.typeIcon = "image";
            }
            this.filter = feature.getFilter();
            if (this.filter == null)
                this.filter = { display: false };
            let select = document.getElementById("selectWithValue");
            if (feature.getWithValue() && feature.getWithValue() != "none") {
                this.withValue = true;
                if (select)
                    select.disabled = false;
            }
            else {
                this.withValue = false;
                if (select)
                    select.disabled = true;
            }
        }
    }
    setWithValue() {
        let select = document.getElementById("selectWithValue");
        if (this.withValue)
            select.disabled = false;
        else
            select.disabled = true;
    }
    addValue(feature) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log("add value to " + feature.getName());
            yield this.featureService.addFeatureValue(feature);
            console.log("feature", feature);
        });
    }
    removeValue(feature, value) {
        var index = feature.getValues().indexOf(value);
        if (index == -1)
            feature.addValue(value);
        else
            feature.getValues().splice(index, 1);
    }
    imgFeatureSelected(feature, value, icon) {
        console.log("select", icon);
        console.log("select", value);
        value[feature.getNameValue()[1]] = icon;
        console.log("select", value);
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
}
FeatureCreatePanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-feature-create-panel-view',
                template: "<ion-segment scrollable (ionChange)=\"segmentChanged($event)\" [(ngModel)]=\"steps\">\n    <ion-segment-button value=\"infos\">\n        <ion-label>Informations</ion-label>\n    </ion-segment-button>\n    <ion-segment-button value=\"icone\">\n        <ion-label>Affichage</ion-label>\n    </ion-segment-button>\n    <ion-segment-button value=\"values\">\n        <ion-label>Valeurs</ion-label>\n    </ion-segment-button>\n</ion-segment>\n\n<form [formGroup]=\"featureForm\" (ngSubmit)=\"onSubmitForm()\">\n    <div [ngSwitch]=\"steps\" id=\"steps\">\n        <div  *ngSwitchCase=\"'infos'\">\n            <ion-list>\n                <ion-item lines=\"none\">\n                    <ion-label position=\"floating\">Id</ion-label>\n                    <ion-input id=\"id\" [(ngModel)]=\"id\" [ngModelOptions]=\"{standalone: true}\" disabled></ion-input>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label position=\"floating\">Nom</ion-label>\n                    <ion-input id=\"name\" formControlName=\"name\" clearInput required></ion-input>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label position=\"floating\">Description</ion-label>\n                    <ion-textarea id=\"description\" maxlength=\"200\" formControlName=\"description\" rows=\"3\" cols=\"20\" placeholder=\"Description rapide de 200 caract\u00E8res max\"></ion-textarea>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label position=\"none\">Icone <ion-icon (click)=\"seeTips($event,'Cette image sera utilis\u00E9 dans les caract\u00E9ristiques des produits')\" class=\"info\" name=\"information-circle-outline\"></ion-icon></ion-label>  \n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label>Type</ion-label>\n                    <ion-select id=\"type\" formControlName=\"type\">\n                        <ion-select-option value=\"number\">Nombre</ion-select-option>\n                        <ion-select-option value=\"string\">Chaine de caract\u00E8res</ion-select-option>\n                        <ion-select-option value=\"map\">Tableau associatif (Map)</ion-select-option>\n                        <ion-select-option value=\"array\">Tableau</ion-select-option>\n                    </ion-select>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label >Nom des valeurs</ion-label>\n                    <ion-input id=\"nameValue\" formControlName=\"nameValue\"></ion-input>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label>Type des valeurs</ion-label>\n                    <ion-input id=\"typeValue\" formControlName=\"typeValue\"></ion-input>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label>Multiple valeurs ?</ion-label>\n                    <ion-checkbox  slot=\"start\" id=\"multiple\" formControlName=\"multiple\"></ion-checkbox>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label>Sous cat\u00E9gorie pour les recherches ?</ion-label>\n                    <ion-checkbox slot=\"start\" id=\"withCategory\" formControlName=\"withCategory\"></ion-checkbox>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label>Peut-on lui assigner une valeur ?</ion-label>\n                    <ion-select id=\"selectWithValue\" formControlName=\"withValue\">\n                        <ion-select-option value=\"string\">Chaine de caract\u00E8res</ion-select-option>\n                        <ion-select-option value=\"number\">Nombre</ion-select-option>\n                    </ion-select>\n                    <ion-checkbox slot=\"start\" id=\"withValue\" [(ngModel)]=\"withValue\" [ngModelOptions]=\"{standalone: true}\" (ionChange)=\"setWithValue()\"></ion-checkbox>\n                </ion-item>\n            </ion-list>\n        </div>\n        <div  *ngSwitchCase=\"'icone'\">\n            <ion-list>\n                <ion-item lines=\"none\">\n                    <ctl-file-chooser [ratio]=\"1\" type=\"['image']\" [file]=\"icon\" [fileName]=\"nameIcon\" [extension]=\"extensionIcon\" typeSelected=\"image\" (fileSelected)=\"iconSelected($event)\"></ctl-file-chooser>    \n                </ion-item>     \n                <ion-item lines=\"none\">\n                    <ion-label position=\"floating\">Ordre</ion-label>\n                    <ion-input id=\"order\" formControlName=\"order\"></ion-input>\n                </ion-item>\n                <ion-item lines=\"none\">\n                    <ion-label>Apparait dans les champs de recherche ?</ion-label>\n                    <ion-checkbox slot=\"start\" id=\"filter\" [(ngModel)]=\"filter.display\" [ngModelOptions]=\"{standalone: true}\"></ion-checkbox>\n                </ion-item>\n            </ion-list>\n        </div>\n        <div  *ngSwitchCase=\"'values'\">\n            <div *ngIf=\"feature\">\n\n            <ion-item *ngIf=\"feature.getType() == 'map'\" lines=\"none\">\n                <ion-label position=\"floating\">Valeurs</ion-label>\n                <div class=\"list-value\" *ngFor=\"let value of feature.getValues() | sort: {property: this.feature.getNameValue()[0], order: order}\">\n                    <ion-input *ngIf=\"feature.getTypeValue()[1] != 'file' && feature.getDisplay().label\" value=\"{{feature.getNameValue()[0]}}:{{value[feature.getNameValue()[0]]}}{{feature.getDisplay().separate}}{{feature.getNameValue()[1]}}:{{value[feature.getNameValue()[1]]}}\"></ion-input>\n                    <ion-input *ngIf=\"feature.getTypeValue()[1] != 'file' && !feature.getDisplay().label\" value=\"{{value[feature.getNameValue()[0]]}}{{feature.getDisplay().separate}}{{value[feature.getNameValue()[1]]}}\"></ion-input>\n                    \n                    <ion-input class=\"icon-label\" *ngIf=\"feature.getTypeValue()[1] == 'file'\" value=\"{{value[feature.getNameValue()[0]]}}\"></ion-input>\n                    <ion-img class=\"icon\" *ngIf=\"feature.getTypeValue()[1] == 'file' && value[feature.getNameValue()[1]]\" src=\"{{value[feature.getNameValue()[1]].data}}\"></ion-img>\n                    <ctl-file-chooser *ngIf=\"feature.getTypeValue()[1] == 'file' && !value[feature.getNameValue()[1]]\" type=\"[{{feature.getDisplay().type}}]\" [display]=\"false\" (fileSelected)=\"imgFeatureSelected(feature,value,$event)\"></ctl-file-chooser>\n                    <ion-button size=\"small\" fill=\"clear\" slot=\"only-icon\" (click)=\"removeValue(feature,value)\"><ion-icon name=\"close-circle-outline\"></ion-icon></ion-button>\n                </div>\n            </ion-item>\n\n            <ion-item *ngIf=\"feature.getType() == 'number' || feature.getType() == 'string'\" lines=\"none\">\n                <ion-label position=\"floating\">Valeurs</ion-label>\n                <div class=\"list-value\" *ngFor=\"let value of feature.getValues() | sortValue: {property: column, order: order}\">\n                    <ion-input value=\"{{value}}\"></ion-input>\n                    <ion-button size=\"small\" fill=\"clear\" slot=\"only-icon\" (click)=\"removeValue( feature, value )\"><ion-icon name=\"close-circle-outline\"></ion-icon></ion-button>\n                </div>\n            </ion-item>\n            \n            <ion-button (click)=\"addValue(feature)\" size=\"small\" expand=\"block\">\n                <ion-icon name=\"add-circle-outline\"></ion-icon> Ajouter {{feature.getName()}}\n            </ion-button>  \n            </div>\n        </div>\n    </div>\n</form>\n\n",
                styles: [".title{font-weight:700;font-size:1.2em;padding:0!important}.title ion-label{padding:.2em 2em}.description,ion-item{padding:0 2em}.list-value{display:inline-block;vertical-align:center}.list-value ion-input{float:left;width:75%}.list-value ion-button{float:right;width:20%}"]
            },] }
];
FeatureCreatePanelViewComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: DisplayerService },
    { type: FeatureService }
];

class FeatureCreatePanelViewComponentModule {
}
FeatureCreatePanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FeatureCreatePanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                    TextRichComponentModule,
                    FileChooserComponentModule,
                    FileChooserComponentModule
                ],
                providers: [],
                exports: [
                    FeatureCreatePanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class FeatureFormDisplayViewComponent {
    constructor() {
        this.select = new EventEmitter();
        this.isAdmin = false;
        this.feature = null;
        this.values = [];
    }
    ngOnInit() {
        console.log(this.values);
    }
    selectValue(values) {
        console.log(values);
        if (this.feature)
            this.select.emit({ feature: this.feature, values: values });
    }
}
FeatureFormDisplayViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-feature-form-display-view',
                template: "<ctl-feature-map-form-display-view [feature]=\"feature\" [values]=\"values\" (select)=\"selectValue($event)\" *ngIf=\"feature!=null && feature.getType() == 'map'\"></ctl-feature-map-form-display-view>\n<ctl-feature-value-form-display-view [feature]=\"feature\" [values]=\"values\" (select)=\"selectValue($event)\" *ngIf=\"feature!=null && feature.getType() !='map'\"></ctl-feature-value-form-display-view>",
                styles: ["ctl-feature-map-form-display-view,ctl-feature-value-form-display-view{width:100%}"]
            },] }
];
FeatureFormDisplayViewComponent.ctorParameters = () => [];
FeatureFormDisplayViewComponent.propDecorators = {
    select: [{ type: Output }],
    isAdmin: [{ type: Input }],
    feature: [{ type: Input }],
    values: [{ type: Input }]
};

class FeatureMapFormDisplayViewComponent {
    constructor(featureService) {
        this.featureService = featureService;
        this.select = new EventEmitter();
        this.feature = null;
        this.isAdmin = false;
        this.values = [];
        this.descending = true;
        this.order = 1;
        this.column = 'value[this.feature.nameValue[0]]';
        this.columnKey = 'key';
    }
    ngOnInit() {
    }
    getValue(value) {
        console.log("value", value);
        if (this.feature)
            return value[this.feature.getNameValue()[0]] + this.feature.getDisplay()['separate'] + value[this.feature.getNameValue()[1]];
        else
            return null;
    }
    myValues() {
        if (this.feature) {
            if (this.feature.getMultiple()) {
                console.log("values of " + this.feature.getName(), this.values);
                return this.values;
            }
            else {
                console.log("values of " + this.feature.getName(), this.values);
                return this.getValue(this.values);
            }
        }
        else
            return null;
    }
    addValue() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.feature)
                yield this.featureService.addFeatureValue(this.feature).then((value) => {
                    if (value && this.feature) {
                        this.featureService.updateFeature(this.feature, false);
                        this.selectValue(value);
                    }
                });
        });
    }
    setValue(values) {
        this.values = values;
    }
    selectValue(values) {
        console.log("select value map", values);
        if (this.feature) {
            if (this.values != [] && this.values != null && values != null && values != "" && values != []) {
                if (this.feature.getMultiple()) {
                    this.values = values;
                    console.log("select value map multiple", values, this.values);
                    this.select.emit(this.values);
                }
                else {
                    this.values = [];
                    if (Array.isArray(values))
                        this.values.push(values[0]);
                    else
                        this.values.push(values);
                    console.log("select value map not multiple", values, this.values);
                    this.select.emit(this.values);
                }
            }
        }
    }
    compareImgFn(e1, e2) {
        if ((!e1 || !e2) || this.feature == null)
            return false;
        else {
            if (Array.isArray(e2)) {
                var insert = false;
                for (let v of e2)
                    if (e1[this.feature.getNameValue()[0]] == v[this.feature.getNameValue()[0]])
                        insert = true;
                return insert;
            }
            else {
                return (e1 && e2) ? e1[this.feature.getNameValue()[0]] == e2[this.feature.getNameValue()[0]] : false;
            }
        }
    }
    compareFn(e1, e2) {
        if ((!e1 || !e2) || this.feature == null)
            return false;
        if (Array.isArray(e2)) {
            var insert = false;
            for (let v of e2)
                if (e1[this.feature.getNameValue()[0]] == v[this.feature.getNameValue()[0]] && e1[this.feature.getNameValue()[1]] == v[this.feature.getNameValue()[1]])
                    insert = true;
            return insert;
        }
        else {
            return (e1 && e2) ? e1[this.feature.getNameValue()[0]] == e2[this.feature.getNameValue()[0]] && e1[this.feature.getNameValue()[1]] == e2[this.feature.getNameValue()[1]] : false;
        }
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
}
FeatureMapFormDisplayViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-feature-map-form-display-view',
                template: "<ion-item lines=\"none\" *ngIf=\"feature != null\">\n    <ion-label position=\"floating\">{{feature.getName()}}</ion-label>\n    <div *ngIf=\"feature.getDisplay()['type'] != 'image'\" class=\"list-value\">\n      <ion-select #select  [value]=\"values\" [compareWith]=\"compareFn.bind(this)\" (ionChange)=\"selectValue(select.value)\" [multiple]=\"feature.getMultiple()\" placeholder=\"S\u00E9lectionnez votre {{feature.getName()}}\">\n        <ion-select-option [value]=\"value\" *ngFor=\"let value of feature.getValues() | sort: {property: this.feature.getNameValue()[0], order: order}\">{{value[this.feature.getNameValue()[0]]}}{{this.feature.getDisplay()['separate']}}{{value[this.feature.getNameValue()[1]]}}</ion-select-option>\n      </ion-select>\n      <div class=\"customValue\" *ngIf=\"feature.getWithValue() != 'none'\">\n          <ion-input [type]=\"feature.getMultiple()\"></ion-input>\n      </div>\n      <ion-button *ngIf=\"isAdmin\" (click)=\"addValue()\"><ion-icon name=\"add\"></ion-icon></ion-button>\n    </div>\n    <div *ngIf=\"feature.getDisplay()['type'] == 'image'\" class=\"list-value\">\n      <ion-select #select [value]=\"values\" [compareWith]=\"compareImgFn.bind(this)\" (ionChange)=\"selectValue(select.value)\" [multiple]=\"feature.getMultiple()\" placeholder=\"S\u00E9lectionnez votre {{feature.getName()}}\">\n        <ion-select-option [value]=\"value\" *ngFor=\"let value of feature.getValues() | sort: {property: this.feature.getNameValue()[0], order: order}\">{{value[feature.getNameValue()[0]]}}</ion-select-option>\n      </ion-select>\n      <ion-button *ngIf=\"isAdmin\" (click)=\"addValue()\"><ion-icon name=\"add\"></ion-icon></ion-button>\n    </div>\n  </ion-item>",
                styles: [".list-value,ion-item{width:100%!important}.list-value{display:inline-block;vertical-align:center}.list-value ion-select{float:left;width:100%!important}.list-value ion-button{float:right;width:20%!important}"]
            },] }
];
FeatureMapFormDisplayViewComponent.ctorParameters = () => [
    { type: FeatureService }
];
FeatureMapFormDisplayViewComponent.propDecorators = {
    select: [{ type: Output }],
    feature: [{ type: Input }],
    isAdmin: [{ type: Input }],
    values: [{ type: Input }]
};

class FeatureValueFormDisplayViewComponent {
    constructor(featureService) {
        this.featureService = featureService;
        this.select = new EventEmitter();
        this.feature = null;
        this.isAdmin = false;
        this.valuesWithValue = new Map();
        this.descending = true;
        this.order = -1;
        this.column = 'value';
        this.columnKey = 'key';
        //this.valuesWithValue.values()
    }
    ngOnInit() {
        /*if(this.feature.withValue == "none")
          this.values = Array<any>();
        else
          this.values = new Map<string,string>();*/
        console.log("init values", this.values);
    }
    myValues() {
        if (this.feature) {
            if (this.feature.getMultiple()) {
                return this.values;
            }
            else {
                return this.values[0];
            }
        }
        else
            return null;
    }
    addValue() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.feature)
                yield this.featureService.addFeatureValue(this.feature).then((value) => {
                    if (value && this.feature) {
                        this.featureService.updateFeature(this.feature, false);
                    }
                    this.selectValue(value);
                });
        });
    }
    selectValue(values) {
        if (this.feature) {
            if (this.feature.getWithValue() == "none")
                this.values = Array();
            else
                this.values = new Map();
            console.log("select feature", this.feature.getWithValue(), "values", this.values, "value", values);
            if (values != null && values != "" && values != []) {
                if (this.feature.getMultiple()) {
                    if (this.feature.getWithValue() == "none")
                        this.values = values;
                    else {
                        if (values instanceof Map)
                            values.forEach((values, key) => {
                                this.values.set(key, values);
                            });
                        else
                            for (let value of values)
                                this.values.set(value, null);
                    }
                }
                else {
                    if (this.feature.getWithValue() == "none")
                        this.values.push(values);
                    else
                        this.values.set(values, null);
                }
                console.log(this.values);
                this.select.emit(this.values);
            }
        }
    }
    setValue(value, withValue) {
        console.log("value", value, "with", withValue);
        this.values.set(value, withValue);
        this.select.emit(this.values);
    }
    compareFn(e1, e2) {
        if ((!e1 || !e2) || this.feature == null)
            return false;
        if (Array.isArray(e2)) {
            var insert = false;
            for (let v of e2) {
                if (e1 == v)
                    insert = true;
            }
            return insert;
        }
        else {
            if (this.feature.getWithValue() == "none")
                return (e1 && e2) ? e1 == e2 : false;
            else {
                if (e2 instanceof Map) {
                    if (e2.size == 0)
                        return false;
                    else {
                        console.log(e1, e2, e2.keys(), e1 == e2.keys().next().value);
                        let insert = false;
                        for (let key of e2.keys())
                            if (e1 == key)
                                insert = true;
                        return insert;
                        //return (e1 == (e2 as Map<any,any>).keys().next().value)? true : false;
                    }
                }
                else {
                    return (e1 && e2) ? e1 == e2 : false;
                }
            }
        }
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
}
FeatureValueFormDisplayViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-feature-value-form-display-view',
                template: "<ion-item lines=\"none\" *ngIf=\"feature != null && feature.getWithValue() =='none'\">\n    <ion-label position=\"floating\">{{feature.getName()}}</ion-label>\n    <div class=\"list-value\" *ngIf=\"feature.getMultiple()\">\n      <ion-select #select [value]=\"values\" (ionChange)=\"selectValue(select.value)\" [compareWith]=\"compareFn.bind(this)\" [multiple]=\"feature.getMultiple()\" placeholder=\"S\u00E9lectionnez votre {{feature.getName()}}\">\n        <ion-select-option [value]=\"value\" *ngFor=\"let value of feature.getValues()\">{{value}}</ion-select-option>\n      </ion-select>\n      <ion-button *ngIf=\"isAdmin\" (click)=\"addValue()\"><ion-icon name=\"add\"></ion-icon></ion-button>\n    </div>\n    <div class=\"list-value\" *ngIf=\"!(feature.getMultiple())\">\n      <ion-select #select [value]=\"values[0]\" (ionChange)=\"selectValue(select.value)\"  [compareWith]=\"compareFn.bind(this)\" [multiple]=\"feature.getMultiple()\" placeholder=\"S\u00E9lectionnez votre {{feature.getName()}}\">\n        <ion-select-option [value]=\"value\" *ngFor=\"let value of feature.getValues()\">{{value}}</ion-select-option>\n      </ion-select>\n      <ion-button *ngIf=\"isAdmin\" (click)=\"addValue()\"><ion-icon name=\"add\"></ion-icon></ion-button>\n    </div>\n  </ion-item>\n  \n  \n  <ion-item lines=\"none\" *ngIf=\"feature != null && feature.getWithValue() !='none'\">\n    <ion-label position=\"floating\">{{feature.getName()}}</ion-label>\n    <div class=\"list-value\" *ngIf=\"feature.getMultiple()\">\n      <ion-select #select [value]=\"values\" (ionChange)=\"selectValue(select.value)\"  [compareWith]=\"compareFn.bind(this)\" [multiple]=\"feature.getMultiple()\" placeholder=\"S\u00E9lectionnez votre {{feature.getName()}}\">\n        <ion-select-option [value]=\"value\" *ngFor=\"let value of feature.getValues() | sort: {property: column, order: order}\">{{value}}</ion-select-option>\n      </ion-select>\n      <ion-button *ngIf=\"isAdmin\" (click)=\"addValue()\"><ion-icon name=\"add\"></ion-icon></ion-button>\n    </div>\n    <div class=\"list-value\" *ngIf=\"!(feature.getMultiple())\">\n      <ion-select #select [value]=\"values[0]\" (ionChange)=\"selectValue(select.value)\" [compareWith]=\"compareFn.bind(this)\" [multiple]=\"feature.getMultiple()\" placeholder=\"S\u00E9lectionnez votre {{feature.getName()}}\">\n        <ion-select-option [value]=\"value\" *ngFor=\"let value of feature.getValues() | sort: {property: column, order: order}\">{{value}}</ion-select-option>\n      </ion-select>\n      <ion-button *ngIf=\"isAdmin\" (click)=\"addValue()\"><ion-icon name=\"add\"></ion-icon></ion-button>\n    </div>\n  </ion-item>\n  \n  \n  <div class=\"customValue\" *ngIf=\"feature != null && feature.getWithValue() != 'none'\">\n    <ion-item lines=\"none\" *ngFor=\"let value of values | keyvalue | sort: {property: columnKey, order: order}\">\n      <ion-label position=\"fixed\">{{value.key}}</ion-label>\n      <ion-input #withValue [value]=\"value.value\" [type]=\"feature.getWithValue()\"></ion-input>\n      <ion-button (click)=\"setValue(value.key,withValue.value)\">Go</ion-button>\n    </ion-item>\n  </div>\n  ",
                styles: [".list-value,ion-item{width:100%!important}.list-value{display:inline-block;vertical-align:center}.list-value ion-select{float:left;width:75%!important}.list-value ion-button{float:right;width:20%!important}.customValue{margin:0 2em}"]
            },] }
];
FeatureValueFormDisplayViewComponent.ctorParameters = () => [
    { type: FeatureService }
];
FeatureValueFormDisplayViewComponent.propDecorators = {
    select: [{ type: Output }],
    feature: [{ type: Input }],
    isAdmin: [{ type: Input }],
    values: [{ type: Input }]
};

class FeatureFormDisplayViewComponentModule {
}
FeatureFormDisplayViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FeatureFormDisplayViewComponent,
                    FeatureMapFormDisplayViewComponent,
                    FeatureValueFormDisplayViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                providers: [],
                exports: [
                    FeatureFormDisplayViewComponent,
                    FeatureMapFormDisplayViewComponent,
                    FeatureValueFormDisplayViewComponent,
                ],
                entryComponents: [],
            },] }
];

class VariationListPanelViewComponent {
    constructor() {
        this.view = new EventEmitter();
        this.remove = new EventEmitter();
        this.variationSelect = null;
        this.variations = [];
        this.variationsSelected = [];
        this.descending = true;
        this.order = 1;
        this.column = "name";
        this.terms = "";
        this.searchColumn = "name";
    }
    ngOnInit() {
    }
    loadVariations(variations) {
        this.variations = variations;
    }
    setVariations(variations) {
        this.variationsSelected = variations;
    }
    removeVariation(variation) {
        this.remove.emit(variation);
    }
    selectVariation(variation) {
        this.variationSelect = variation;
        this.view.emit(variation);
    }
    tracking(index, variation) {
        return variation.getId();
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
}
VariationListPanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-variation-list-panel-view',
                template: "<div slot=\"fixed\">\n    <ion-searchbar [(ngModel)]=\"terms\" animated></ion-searchbar>\n  </div>\n  <ion-list *ngIf=\"variations.length != 0\">\n    <ion-item-sliding #slidingItem *ngFor=\"let variation of variations | sort: {property: column, order: order} | search: {property: searchColumn,terms: terms} ; trackBy:tracking\">\n      <ion-item lines=\"full\" (click)=\"selectVariation(variation)\" [ngClass]=\"{'selected':variation.getId() === variationSelect?.getId()}\">\n        {{variation.getName()}}\n      </ion-item>\n      <ion-item-options side=\"end\">\n        <ion-button color=\"danger\" (click)=\"removeVariation(variation)\" slot=\"icon-only\">\n          <ion-icon name=\"trash-outline\"></ion-icon>\n        </ion-button>\n      </ion-item-options>\n    </ion-item-sliding>\n  </ion-list>\n  \n  <ion-list class=\"block\" *ngIf=\"variations.length == 0\">\n    <ion-item lines=\"none\">          \n      <ion-list id=\"list-cat-skelet\">\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n      </ion-list>\n    </ion-item>\n  </ion-list>\n",
                styles: ["ion-avatar{min-width:2em;margin-right:1em}ion-list{width:100%}.wait{--background:var(--ion-color-warning)}.reject{--background:var(--ion-color-danger);color:#fff}.selected{--background:var(--ion-color-secondary)!important;background-color:var(--ion-color-secondary)!important}#list-cat-skelet ion-item,.indent{margin:0}.indent{padding:0 0 0 2em}.item0{padding:0;margin:0}.item1{margin:0;padding:0 0 0 2em}.item2{margin:0;padding:0 0 0 4em}"]
            },] }
];
VariationListPanelViewComponent.ctorParameters = () => [];
VariationListPanelViewComponent.propDecorators = {
    view: [{ type: Output }],
    remove: [{ type: Output }]
};

class VariationListPanelViewComponentModule {
}
VariationListPanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    VariationListPanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                providers: [],
                exports: [
                    VariationListPanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class VariationCreatePanelViewComponent {
    constructor(formBuilder, displayer, variationService) {
        this.formBuilder = formBuilder;
        this.displayer = displayer;
        this.variationService = variationService;
        this.variation = null;
        this.values = [];
        this.descending = true;
        this.order = 1;
        this.column = 'value';
        this.columnKey = 'key';
        this.variationForm = this.formBuilder.group({
            name: ['', Validators.required],
            description: ['', Validators.required]
        });
    }
    ngOnInit() {
    }
    select(variation) {
        return __awaiter(this, void 0, void 0, function* () {
            this.values = [];
            yield this.displayer.presentLoader();
            this.variation = variation;
            this.variationForm.setValue({
                name: variation.getName(),
                description: variation.getDescription()
            });
            this.values = variation.getValues();
            yield this.displayer.dismissLoader();
        });
    }
    onSubmitForm() {
    }
    addValue() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.variation) {
                console.log("add value to " + this.variation.getName());
                yield this.variationService.addVariationValue(this.variation);
                console.log("variation", this.variation);
            }
        });
    }
    removeValue(value) {
    }
    imgVariationSelected(value, icon) {
        console.log("select", icon);
        console.log("select", value);
        value[this.variation.getNameValue()[1]] = icon;
        console.log("select", value);
    }
}
VariationCreatePanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-variation-create-panel-view',
                template: "<ion-list *ngIf=\"variation != null\">\n    <form [formGroup]=\"variationForm\" (ngSubmit)=\"onSubmitForm()\">\n    <!--<ion-item lines=\"full\" class=\"title\"><ion-label>{{variation.getName()}}</ion-label></ion-item>-->\n    \n    <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Nom</ion-label>\n        <ion-input formControlName=\"description\" clearInput required></ion-input>\n      </ion-item>\n\n    <ion-item lines=\"none\">\n      <ion-label position=\"floating\">Description</ion-label>\n      <ion-input formControlName=\"description\" clearInput required></ion-input>\n    </ion-item>\n    \n    <ion-button *ngIf=\"variation.getType() == 'array'\" (click)=\"addValue()\" size=\"small\" expand=\"block\"><ion-icon name=\"add-circle-outline\"></ion-icon> Ajouter {{variation.getName()}}</ion-button>\n    <div *ngIf=\"values.length >0\">\n    <ion-item *ngIf=\"variation.getType() == 'array'\" lines=\"none\">\n      <ion-label position=\"floating\">Valeurs</ion-label>\n      <div class=\"list-value\" *ngFor=\"let value of values | sort: {property: column, order: order}\">\n        <ion-input value=\"{{value}}\"></ion-input>\n        <ion-button size=\"small\" fill=\"clear\" slot=\"only-icon\" (click)=\"removeValue(value)\"><ion-icon name=\"close-circle-outline\"></ion-icon></ion-button>\n      </div>\n    </ion-item>\n\n    <!--<ion-button *ngIf=\"variation.getType() == 'map'\" (click)=\"addValue()\" size=\"small\" expand=\"block\"><ion-icon name=\"add-circle-outline\"></ion-icon> Ajouter {{variation.getName()}}</ion-button>\n    <ion-item *ngIf=\"variation.getType() == 'map'\" lines=\"none\">\n      <ion-label position=\"floating\">Valeurs</ion-label>\n      <div class=\"list-value\" *ngFor=\"let value of variation.getValues()\">\n        <ion-input *ngIf=\"variation.getTypeValue()[1] != 'file' && variation.getDisplay().label\" value=\"{{variation.getNameValue()[0]}}:{{value[variation.getNameValue()[0]]}}{{variation.getDisplay().separate}}{{variation.getNameValue()[1]}}:{{value[variation.getNameValue()[1]]}}\"></ion-input>\n        <ion-input *ngIf=\"variation.getTypeValue()[1] != 'file' && !variation.getDisplay().label\" value=\"{{value[variation.getNameValue()[0]]}}{{variation.getDisplay().separate}}{{value[variation.getNameValue()[1]]}}\"></ion-input>\n        \n        <ion-input class=\"icon-label\" *ngIf=\"(variation.getTypeValue()[1] == 'file' && variation.getDisplay().label)\" value=\"{{value[variation.getNameValue()[0]]}}\"></ion-input>\n        <ion-img class=\"icon\" *ngIf=\"variation.getTypeValue()[1] == 'file' && value[variation.getNameValue()[1]]\" src=\"{{value[variation.getNameValue()[1]].data}}\"></ion-img>\n        <ctl-file-chooser *ngIf=\"variation.getTypeValue()[1] == 'file' && !value[variation.getNameValue()[1]]\" type=\"[{{variation.getDisplay().type}}]\" [display]=\"false\" (fileSelected)=\"imgVariationSelected(value,$event)\"></ctl-file-chooser>\n        <ion-button size=\"small\" fill=\"clear\" slot=\"only-icon\" (click)=\"removeValue(value)\"><ion-icon name=\"close-circle-outline\"></ion-icon></ion-button>\n      </div>\n    </ion-item>-->\n    \n    <ion-button  *ngIf=\"variation.getType() == 'number' || variation.getType() == 'string'\" (click)=\"addValue()\" size=\"small\" expand=\"block\"><ion-icon name=\"add-circle-outline\"></ion-icon> Ajouter {{variation.getName()}}</ion-button>  \n    <ion-item *ngIf=\"variation.getType() == 'number' || variation.getType() == 'string'\" lines=\"none\">\n      <ion-label position=\"floating\">Valeurs</ion-label>\n      <div class=\"list-value\" *ngFor=\"let value of values | sortValue: {order: order} \">\n        <ion-input value=\"{{value}}\"></ion-input>\n        <ion-button size=\"small\" fill=\"clear\" slot=\"only-icon\" (click)=\"removeValue(value)\"><ion-icon name=\"close-circle-outline\"></ion-icon></ion-button>\n      </div>\n    </ion-item>\n</div>\n    </form>\n</ion-list>",
                styles: [".title{font-weight:700;font-size:1.2em;padding:0!important}.title ion-label{padding:.2em 2em}.description,ion-item{padding:0 2em}ion-item{vertical-align:top;width:100%}.list-value{display:inline-block;vertical-align:center;width:100%;height:2em}.list-value ion-input{float:left;vertical-align:center;width:75%}.list-value .icon-label{float:left;vertical-align:center;width:55%!important}.list-value .icon,.list-value file-chooser{width:20%;float:left}.list-value .icon{height:2em;vertical-align:center;text-align:center}.list-value ion-button{float:right;width:20%}#steps{width:100%}"]
            },] }
];
VariationCreatePanelViewComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: DisplayerService },
    { type: VariationService }
];

class VariationCreatePanelViewComponentModule {
}
VariationCreatePanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    VariationCreatePanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                    TextRichComponentModule,
                    FileChooserComponentModule,
                    FileChooserComponentModule
                ],
                providers: [],
                exports: [
                    VariationCreatePanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class ProductListPanelViewComponent {
    constructor(makerService) {
        this.makerService = makerService;
        this.view = new EventEmitter();
        this.remove = new EventEmitter();
        this.edit = new EventEmitter();
        this.productSelected = null;
        this.products = null;
        this.makersId = null;
        this.descending = true;
        this.order = 1;
        this.column = 'title';
        this.terms = "";
        this.searchColumn = "title";
        this.makersSubscribe = this.makerService.getMakersIdObs().subscribe(makers => {
            if (makers) {
                this.makersId = makers;
            }
        });
    }
    ngOnInit() {
    }
    ngOnDestroy() {
        this.makersSubscribe.unsubscribe();
    }
    getManufacturerName(product) {
        if (this.makersId) {
            let m = this.makersId.get(product.getMaker());
            if (m)
                return m.getName();
            else
                return "";
        }
        else
            return "";
    }
    loadProducts(products) {
        this.products = products;
    }
    removeProduct(product) {
        this.remove.emit(product);
    }
    editCategory(product) {
        this.productSelected = product;
        this.view.emit(product);
    }
    selectProduct(product) {
        console.log("product selected", product);
        this.productSelected = product;
        this.view.emit(this.productSelected);
    }
    trackProducts(index, product) {
        return product.getId();
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
}
ProductListPanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-product-list-panel-view',
                template: "\n<ion-list class=\"block\" *ngIf=\"products != null\">\n  <ion-list-header position=\"sticky\"><ion-searchbar animated [(ngModel)]=\"terms\"></ion-searchbar></ion-list-header>\n  \n  <div scrollY=\"true\" id=\"scroll-list\">\n    <ion-item-sliding #slidingItem *ngFor=\"let product of products | search :{property: searchColumn, terms: terms} | sort: {property: column, order: order} ; trackBy:trackProducts\">\n      <ion-item lines=\"full\" (click)=\"selectProduct(product)\" [ngClass]=\"{'selected':product.getId() === productSelected?.getId(), 'reject':product.getStatut() === 'reject', 'wait':product.getStatut() === 'wait'}\">\n        <ion-avatar><ion-img src=\"{{product.getThumb()?.data}}\"></ion-img></ion-avatar> {{product.getTitle()}} de  {{getManufacturerName(product)}}\n      </ion-item>\n      <ion-item-options side=\"end\">\n        <ion-button color=\"danger\" (click)=\"removeProduct(product)\" slot=\"icon-only\">\n          <ion-icon name=\"trash-outline\"></ion-icon>\n        </ion-button>\n        <!--<ion-button color=\"success\" (click)=\"editCategory(category)\"  slot=\"icon-only\">\n          <ion-icon name=\"create-outline\"></ion-icon>\n        </ion-button>-->\n      </ion-item-options>\n    </ion-item-sliding>\n  </div>\n</ion-list>\n\n  \n  \n  <ion-list class=\"block\" *ngIf=\"products == null\">\n    <ion-item lines=\"none\">          \n      <ion-list id=\"list-skelet\">\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item1\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item1\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item2\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n        <ion-item lines=\"none\" class=\"item0\">\n          <ion-skeleton-text animated style=\"width: 1.5em; height: 1.5em\" slot=\"start\"></ion-skeleton-text>\n          <ion-skeleton-text animated style=\"height: 1.5em\"></ion-skeleton-text>\n        </ion-item>\n      </ion-list>\n    </ion-item>\n  </ion-list>",
                styles: [".fixed-top{position:fixed;height:2.5em;z-index:99}ion-avatar{min-width:2em;margin-right:1em}ion-list{width:100%}#scroll-list{width:100%;height:100%}.wait{--background:var(--ion-color-warning)}.reject{--background:var(--ion-color-danger);color:#fff}.selected{--background:var(--ion-color-secondary)!important;background-color:var(--ion-color-secondary)!important}#list-skelet ion-item{margin:0}"]
            },] }
];
ProductListPanelViewComponent.ctorParameters = () => [
    { type: MakerService }
];
ProductListPanelViewComponent.propDecorators = {
    view: [{ type: Output }],
    remove: [{ type: Output }],
    edit: [{ type: Output }]
};

class ProductListPanelViewComponentModule {
}
ProductListPanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    ProductListPanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                providers: [],
                exports: [
                    ProductListPanelViewComponent
                ],
                entryComponents: [],
            },] }
];

class ProductCreatePanelViewComponent {
    constructor(formBuilder, displayer, manufacturerService, variationService, categoryService) {
        this.formBuilder = formBuilder;
        this.displayer = displayer;
        this.manufacturerService = manufacturerService;
        this.variationService = variationService;
        this.categoryService = categoryService;
        this.update = new EventEmitter();
        this.valid = new EventEmitter();
        this.steps = "";
        this.descending = true;
        this.order = 1;
        this.column = "value";
        this.product = null;
        this.id = "";
        this.description = "";
        this.strengths = [];
        this.strength = "";
        this.keywords = [];
        this.keyword = "";
        this.manufacturers = [];
        this.manufacturersId = null;
        this.manufacturerSelected = null;
        this.categories = [];
        this.categoriesSelected = [];
        this.features = [];
        this.variations = [];
        this.variationsSelected = [];
        this.submitAttempt = false;
        this.productForm = this.formBuilder.group({
            title: ['', Validators.required],
            subtitle: ['', Validators.required],
            manufacturerSelected: ['', Validators.required],
            ean: [''],
            shortdescription: ['', Validators.required],
            shipping_cost: [''],
            weight: [''],
            height: [''],
            width: [''],
            length: [''],
            seodescription: [''],
            hashtag: [''],
            sold: [false, Validators.required],
            samePrice: [true],
            cost: ['']
        }, { validtor: this.costValidator() });
        this.productForm.statusChanges.subscribe((status) => {
            console.log("status", status);
            console.log("cost", this.productForm.controls.cost.value, this.productForm.controls.cost.status);
            this.valid.next((status == "VALID") ? true : false);
        });
    }
    costValidator() {
        return (group) => {
            let soldControl = group.controls['sold'];
            let costControl = group.controls['cost'];
            if (soldControl.value == true && !isNaN(costControl.value) && costControl.value >= 0)
                return { 'costValidator': true };
        };
    }
    sort() {
        this.descending = !this.descending;
        this.order = this.descending ? 1 : -1;
    }
    ngOnInit() {
        this.steps = "infoPanel";
        combineLatest([
            this.manufacturerService.getMakersIdObs(),
            this.manufacturerService.getMakersObs(),
            this.variationService.getVariationsObs(),
            this.categoryService.getCategoriesObs(),
        ]).subscribe(([makersId, makers, variations, categories]) => {
            if (makersId && makers && variations && categories) {
                this.manufacturersId = makersId;
                this.manufacturers = makers;
                this.variations = variations;
                this.categories = categories;
            }
        });
    }
    onSubmitForm() {
        this.submitAttempt = true;
    }
    segmentChanged(panel) {
    }
    onContentChanged(description) {
        this.description = description;
    }
    addStrength() {
        this.strengths.push(this.strength);
        this.strength = "";
    }
    removeStrength(strength) {
        this.strengths.splice(this.strengths.indexOf(strength), 1);
    }
    addKeyword() {
        this.keywords.push(this.keyword);
        this.keyword = "";
    }
    removeKeyword(keyword) {
        this.keywords.splice(this.keywords.indexOf(keyword), 1);
    }
    seeTips($event, message) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.displayer.presentMessagePopover($event, message);
        });
    }
    select(product) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            console.log("select", product, product.getTitle());
            if (product) {
                yield this.displayer.presentLoader();
                this.steps = "infoPanel";
                this.product = product;
                this.id = product.getId();
                this.description = product.getDescription();
                this.strengths = product.getStrengths();
                this.keywords = product.getKeySeo();
                this.productForm.setValue({
                    title: product.getTitle(),
                    subtitle: product.getSubTitle(),
                    shortdescription: product.getShortDescription(),
                    manufacturerSelected: (_a = this.manufacturersId) === null || _a === void 0 ? void 0 : _a.get(product.getMaker()),
                    ean: product.getEan(),
                    weight: product.getWeight(),
                    length: product.getLength(),
                    width: product.getWidth(),
                    height: product.getHeight(),
                    shipping_cost: product.getShippingCost(),
                    seodescription: product.getDescriptionSeo(),
                    hashtag: product.getHashtag(),
                    sold: product.getSold(),
                    samePrice: product.isSamePrice(),
                    cost: product.getCost()
                });
                yield this.displayer.dismissLoader();
            }
        });
    }
    save() {
        console.log("save");
    }
    categorySelect(categories) {
        console.log(categories);
        this.categoriesSelected = categories;
        this.features = [];
        var insert;
        categories.forEach(category => {
            console.log("category features", category);
            category.getFeatures().forEach(feature => {
                console.log("category features feature", feature);
                insert = true;
                this.features.forEach(f => {
                    console.log("category features feature f", f);
                    if (f.getId() == feature)
                        insert = false;
                });
                //if(insert)
                //this.features.push(feature);
            });
        });
        console.log("features", this.features);
    }
    changeCost() {
        console.log("changecost", this.productForm.controls.cost.value);
        console.log("validators", this.productForm.validator);
    }
}
ProductCreatePanelViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'ctl-product-create-panel-view',
                template: "<ion-segment #createSegment scrollable (ionChange)=\"segmentChanged($event)\" [(ngModel)]=\"steps\" *ngIf=\"product\">\n    <ion-segment-button #infoPanel value=\"infoPanel\">\n      <i class=\"fas fa-info-circle\"></i>\n    </ion-segment-button>\n    <ion-segment-button #seoPanel value=\"seoPanel\">\n      <i class=\"fas fa-tag\"></i>\n    </ion-segment-button>\n    <ion-segment-button #deliveryPanel value=\"deliveryPanel\">\n      <i class=\"fas fa-truck\"></i>\n  </ion-segment-button>\n  <ion-segment-button #pricePanel value=\"pricePanel\">\n    <i class=\"fas fa-euro-sign\"></i>\n  </ion-segment-button>\n  <ion-segment-button #quantityPanel value=\"quantityPanel\">\n    <i class=\"fas fa-cube\"></i>\n  </ion-segment-button>\n    <ion-segment-button #categoryPanel value=\"categoryPanel\">\n      <i class=\"far fa-clone\"></i>\n    </ion-segment-button>\n    \n    <ion-segment-button #feturePanel value=\"featurePanel\">\n      <i class=\"fas fa-filter\"></i>\n    </ion-segment-button>\n    <ion-segment-button #imagePanel value=\"imagePanel\">\n      <i class=\"far fa-images\"></i>\n    </ion-segment-button>\n    <ion-segment-button #variationPanel value=\"variationPanel\">\n      <i class=\"fas fa-th\"></i>\n    </ion-segment-button>\n    <ion-segment-button #linkPanel value=\"linkPanel\">\n      <i class=\"fas fa-link\"></i>\n    </ion-segment-button>\n    <ion-segment-button #sendPanel value=\"sendPanel\">\n      <i class=\"far fa-paper-plane\"></i>\n    </ion-segment-button>\n  </ion-segment>\n\n  <form [formGroup]=\"productForm\" (ngSubmit)=\"onSubmitForm()\">\n  <div [ngSwitch]=\"steps\" id=\"steps\" *ngIf=\"product\">\n    <div  *ngSwitchCase=\"'infoPanel'\" id=\"infoPanel\">\n      <ion-item lines=\"full\" class=\"title\"><ion-label>Informations</ion-label></ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Id produit</ion-label>\n        <ion-input id=\"id\" [(ngModel)]=\"id\" [ngModelOptions]=\"{standalone: true}\" disabled></ion-input>\n      </ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Nom</ion-label>\n        <ion-input [class.invalid]=\"!productForm.controls.title.valid  && (productForm.controls.title.dirty || submitAttempt)\" id=\"title\" formControlName=\"title\" clearInput required></ion-input>\n      </ion-item>\n      <ion-item\n  *ngIf=\"!productForm.controls.title.valid  && (productForm.controls.title.dirty || submitAttempt)\"\n>\n  <p>Entrez un nom valide</p>\n</ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Sous titre</ion-label>\n        <ion-input id=\"subtitle\" formControlName=\"subtitle\" clearInput required></ion-input>\n      </ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Fabricant</ion-label>\n        <ion-select #brand okText=\"Ok\" cancelText=\"Annuler\" formControlName=\"manufacturerSelected\">\n          <ion-select-option *ngFor=\"let manufacturer of manufacturers\" [value]=\"manufacturer\">{{manufacturer.getName()}}</ion-select-option>\n        </ion-select>\n      </ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Code barre EAN</ion-label>\n        <ion-input id=\"ean\" formControlName=\"ean\"></ion-input>\n      </ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Description rapide</ion-label>\n        <ion-textarea id=\"shortdescription\" maxlength=\"200\" formControlName=\"shortdescription\" rows=\"3\" cols=\"20\" placeholder=\"Description rapide de 200 caract\u00E8res max\"></ion-textarea>\n      </ion-item>  \n      <ion-item lines=\"none\" id=\"text-rich\">\n        <ctl-text-rich id=\"description\" placeholder=\"Description d\u00E9taill\u00E9e\" [content]=\"description\" (changed)=\"onContentChanged($event)\"></ctl-text-rich>\n      </ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\" id=\"strength-label\">Points forts</ion-label>\n        <ion-input (keyup.enter)=\"addStrength()\" placeholder=\"valider votre saisie en tapant entrer\" id=\"strength-input\" [ngModelOptions]=\"{standalone: true}\" [(ngModel)]=\"strength\"></ion-input>\n      </ion-item>\n      <ul class=\"strength-item\">\n        <li *ngFor=\"let strengthValue of strengths\">{{strengthValue}}<ion-icon (click)=\"removeStrength(strengthValue)\"  name=\"close-circle-outline\"></ion-icon></li>\n      </ul>\n    </div>\n\n    <div *ngSwitchCase=\"'seoPanel'\" id=\"seoPanel\">\n      <ion-item lines=\"full\" class=\"title\"><ion-label>SEO</ion-label></ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Description</ion-label>\n        <ion-textarea id=\"seodescription\" maxlength=\"145\" formControlName=\"seodescription\" rows=\"3\" cols=\"20\" placeholder=\"Description pour le r\u00E9f\u00E9rencement de 145 caract\u00E8res max\"></ion-textarea>\n      </ion-item>  \n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Hashtag</ion-label>\n        <ion-input id=\"hashtag\" formControlName=\"hashtag\" placeholder=\"#\" clearInput></ion-input>  \n      </ion-item>\n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\" id=\"keyword-label\">Mots cl\u00E9s</ion-label>\n        <ion-input (keyup.enter)=\"addKeyword()\" id=\"keyword-input\" placeholder=\"valider votre saisie en tapant entrer\"  [ngModelOptions]=\"{standalone: true}\" [(ngModel)]=\"keyword\"></ion-input>\n      </ion-item>\n      <ul class=\"keyword-item\">\n        <li *ngFor=\"let keyword of keywords\">{{keyword}} <ion-icon (click)=\"removeKeyword(keyword)\"  name=\"close-circle-outline\"></ion-icon></li>\n      </ul>\n    </div>\n\n    <div *ngSwitchCase=\"'deliveryPanel'\" id=\"deliveryPanel\">\n      <ion-item lines=\"full\" class=\"title\"><ion-label>Livraison</ion-label></ion-item>\n      <ion-item>\n        <ion-label position=\"floating\">Tarif</ion-label>\n        <ion-input formControlName=\"shipping_cost\" placeholder=\"Somme en \u20AC \u00E0 ajouter aux frais de port\"></ion-input>\n      </ion-item>  \n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">Poids</ion-label>\n        <ion-input formControlName=\"weight\" placeholder=\"poids en gr\"></ion-input>\n      </ion-item>  \n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">longueur</ion-label>\n        <ion-input formControlName=\"length\"placeholder=\"longueur en cm\"></ion-input>\n      </ion-item>  \n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">largeur</ion-label>\n        <ion-input formControlName=\"width\" placeholder=\"largeur en cm\"></ion-input>\n      </ion-item>  \n      <ion-item lines=\"none\">\n        <ion-label position=\"floating\">hauteur</ion-label>\n        <ion-input formControlName=\"height\" placeholder=\"hauteur en cm\"></ion-input>\n      </ion-item>  \n    </div>\n\n\n    <div  *ngSwitchCase=\"'pricePanel'\" id=\"pricePanel\">\n      <ion-item lines=\"full\" class=\"title\"><ion-label>Prix</ion-label></ion-item>\n      <ion-item lines=\"none\">\n          <ion-toggle formControlName=\"sold\"></ion-toggle>\n          <ion-label>Produit en vente (sinon mode catalogue)</ion-label>    \n      </ion-item>\n      <ion-item lines=\"none\" *ngIf=\"productForm.value.sold\">\n        <ion-toggle formControlName=\"samePrice\"></ion-toggle>\n        <ion-label>Prix identique pour les d\u00E9clinaisons</ion-label>    \n    </ion-item>\n\n    <div id=\"price-shop\" *ngIf=\"productForm.value.sold\">\n        <ion-item lines=\"full\" class=\"title\"><ion-label>Prix boutique</ion-label></ion-item>\n        <ion-item lines=\"none\">\n          <ion-label position=\"floating\">Prix achat HT</ion-label>\n          <ion-input type=\"number\" id=\"cost\" [class.invalid]=\"!productForm.controls.cost.valid  && (productForm.controls.cost.dirty || submitAttempt)\" formControlName=\"cost\" (ionChange)=\"changeCost()\"></ion-input>\n        </ion-item>\n        <span class=\"error ion-padding\"\n          *ngIf=\"!productForm.controls.cost.valid  && (productForm.controls.cost.dirty || submitAttempt)\"\n        >\n          Please enter a valid name.\n        </span>\n       <!-- <ion-item lines=\"none\">\n          <ion-label position=\"floating\">Prix de vente HT</ion-label>\n          <ion-input id=\"price\" formControlName=\"price\" disabled></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\">\n          <ion-label position=\"floating\">Prix de vente TTC</ion-label>\n          <ion-input id=\"priceTTC\" formControlName=\"priceTTC\" (ionChange)=\"changePriceTTC()\"></ion-input>\n        </ion-item>\n        <ion-item>\n          <ion-label position=\"floating\">Coefficient</ion-label>\n          <ion-input id=\"coeff\" formControlName=\"coeff\" disabled></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\">\n          <ion-toggle formControlName=\"reduced\"></ion-toggle>\n          <ion-label>Produit remis\u00E9 ?</ion-label>    \n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"productForm.value.reduced\">\n          <ion-grid>\n            <ion-row>\n              <ion-col size=\"1\">\n                <ion-checkbox [disabled]=\"productForm.value.isValueDiscount\" formControlName=\"isPercentDiscount\"></ion-checkbox>\n              </ion-col>\n              <ion-col size=\"11\">\n                <ion-label position=\"floating\">Poucentage de remise</ion-label>\n                <ion-input [disabled]=\"!productForm.value.isPercentDiscount\" id=\"percentDiscount\" formControlName=\"percentDiscount\" (ionChange)=\"changePourcentDiscount()\"></ion-input>  \n              </ion-col>\n            </ion-row>\n          </ion-grid>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"productForm.value.reduced\">\n          <ion-grid>\n            <ion-row>\n              <ion-col size=\"1\">\n                <ion-checkbox [disabled]=\"productForm.value.isPercentDiscount\" formControlName=\"isValueDiscount\"></ion-checkbox>\n              </ion-col>\n              <ion-col size=\"11\">\n                <ion-label position=\"floating\">Montant de remise</ion-label>\n                <ion-input [disabled]=\"!productForm.value.isValueDiscount\" id=\"valueDiscount\" formControlName=\"valueDiscount\" (ionChange)=\"changeValueDiscount()\"></ion-input>  \n              </ion-col>\n            </ion-row>\n          </ion-grid>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"productForm.value.reduced\">\n          <ion-label position=\"floating\">Prix de vente remis\u00E9</ion-label>\n          <ion-input id=\"priceDiscount\" formControlName=\"priceDiscountTTC\" (ionChange)=\"changePriceDiscount()\" disabled></ion-input>  \n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"productForm.value.reduced\">\n          <ion-label position=\"floating\">Coefficient remis\u00E9</ion-label>\n          <ion-input id=\"coeffDiscount\" formControlName=\"coeffDiscount\" disabled></ion-input>  \n        </ion-item>-->\n      </div>\n    \n  </div>\n      <!--<div id=\"price-shop\" *ngIf=\"sold\">\n        <ion-item lines=\"full\" class=\"title\"><ion-label>Prix boutique</ion-label></ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-label position=\"floating\">Prix achat HT</ion-label>\n          <ion-input id=\"cost\" [(ngModel)]=\"cost\" (ionChange)=\"changeCost()\"></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-label position=\"floating\">Prix de vente HT</ion-label>\n          <ion-input id=\"price\" [(ngModel)]=\"price\" disabled></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-label position=\"floating\">Prix de vente TTC</ion-label>\n          <ion-input id=\"priceTTC\" [(ngModel)]=\"priceTTC\" (ionChange)=\"changePriceTTC()\"></ion-input>\n        </ion-item>\n        <ion-item *ngIf=\"sold\">\n          <ion-label position=\"floating\">Coefficient</ion-label>\n          <ion-input id=\"coeff\" [(ngModel)]=\"coeff\" disabled></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-toggle [(ngModel)]=\"reduced\"></ion-toggle>\n          <ion-label>Produit remis\u00E9 ?</ion-label>    \n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && reduced\">\n          <ion-grid>\n            <ion-row>\n              <ion-col size=\"1\">\n                <ion-checkbox [disabled]=\"isValueDiscount\" [(ngModel)]=\"isPercentDiscount\"></ion-checkbox>\n              </ion-col>\n              <ion-col size=\"11\">\n                <ion-label position=\"floating\">Poucentage de remise</ion-label>\n                <ion-input [disabled]=\"!isPercentDiscount\" id=\"percentDiscount\" [(ngModel)]=\"percentDiscount\" (ionChange)=\"changePourcentDiscount()\"></ion-input>  \n              </ion-col>\n            </ion-row>\n          </ion-grid>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && reduced\">\n          <ion-grid>\n            <ion-row>\n              <ion-col size=\"1\">\n                <ion-checkbox [disabled]=\"isPercentDiscount\" [(ngModel)]=\"isValueDiscount\"></ion-checkbox>\n              </ion-col>\n              <ion-col size=\"11\">\n                <ion-label position=\"floating\">Montant de remise</ion-label>\n                <ion-input [disabled]=\"!isValueDiscount\" id=\"valueDiscount\" [(ngModel)]=\"valueDiscount\" (ionChange)=\"changeValueDiscount()\"></ion-input>  \n              </ion-col>\n            </ion-row>\n          </ion-grid>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && reduced\">\n          <ion-label position=\"floating\">Prix de vente remis\u00E9</ion-label>\n          <ion-input id=\"priceDiscount\" [(ngModel)]=\"priceDiscountTTC\" (ionChange)=\"changePriceDiscount()\" disabled></ion-input>  \n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && reduced\">\n          <ion-label position=\"floating\">Coefficient remis\u00E9</ion-label>\n          <ion-input id=\"coeffDiscount\" [(ngModel)]=\"coeffDiscount\" disabled></ion-input>  \n        </ion-item>\n      </div>\n      <div id=\"price-wshop\" *ngIf=\"sold\">\n        <ion-item lines=\"full\" class=\"title\"><ion-label>Prix web</ion-label></ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-label position=\"floating\">Prix achat HT</ion-label>\n          <ion-input id=\"cost\" [(ngModel)]=\"cost\" disabled></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-label position=\"floating\">Prix de vente HT</ion-label>\n          <ion-input id=\"wprice\" [(ngModel)]=\"wprice\" disabled></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-label position=\"floating\">Prix de vente TTC</ion-label>\n          <ion-input id=\"wpriceTTC\" [(ngModel)]=\"wpriceTTC\" (ionChange)=\"changeWPriceTTC()\"></ion-input>\n        </ion-item>\n        <ion-item *ngIf=\"sold\">\n          <ion-label position=\"floating\">Coefficient</ion-label>\n          <ion-input id=\"wcoeff\" [(ngModel)]=\"wcoeff\" disabled></ion-input>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold\">\n          <ion-toggle [(ngModel)]=\"wreduced\"></ion-toggle>\n          <ion-label>Produit remis\u00E9 ?</ion-label>    \n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && wreduced\">\n          <ion-grid>\n            <ion-row>\n              <ion-col size=\"1\">\n                <ion-checkbox [disabled]=\"isValueWDiscount\" [(ngModel)]=\"isPercentWDiscount\"></ion-checkbox>\n              </ion-col>\n              <ion-col size=\"11\">\n                <ion-label position=\"floating\">Poucentage de remise</ion-label>\n                <ion-input [disabled]=\"!isPercentWDiscount\" id=\"percentWDiscount\" [(ngModel)]=\"percentWDiscount\" (ionChange)=\"changePourcentWDiscount()\"></ion-input>  \n              </ion-col>\n            </ion-row>\n          </ion-grid>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && wreduced\">\n          <ion-grid>\n            <ion-row>\n              <ion-col size=\"1\">\n                <ion-checkbox [disabled]=\"isPercentWDiscount\" [(ngModel)]=\"isValueWDiscount\"></ion-checkbox>\n              </ion-col>\n              <ion-col size=\"11\">\n                <ion-label position=\"floating\">Montant de remise</ion-label>\n                <ion-input [disabled]=\"!isValueWDiscount\" id=\"valueWDiscount\" [(ngModel)]=\"valueWDiscount\" (ionChange)=\"changeValueWDiscount()\"></ion-input>  \n              </ion-col>\n            </ion-row>\n          </ion-grid>\n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && wreduced\">\n          <ion-label position=\"floating\">Prix de vente remis\u00E9</ion-label>\n          <ion-input id=\"priceWDiscount\" [(ngModel)]=\"priceWDiscountTTC\" (ionChange)=\"changePriceWDiscount()\" disabled></ion-input>  \n        </ion-item>\n        <ion-item lines=\"none\" *ngIf=\"sold && wreduced\">\n          <ion-label position=\"floating\">Coefficient remis\u00E9</ion-label>\n          <ion-input id=\"coeffWDiscount\" [(ngModel)]=\"coeffWDiscount\" disabled></ion-input>  \n        </ion-item>\n      </div>\n    </div>-->\n\n\n    <!--<div  *ngSwitchCase=\"'categoryPanel'\" id=\"categoryPanel\">\n      <ion-item lines=\"full\" class=\"title\"><ion-label>Cat\u00E9gories</ion-label></ion-item>\n      <ctl-category-select-list-panel-view #categoriesList [categories]=\"categories\" statut=\"publish\" (select)=\"categorySelect($event)\" (listingCategory)=\"setCategories(categories)\"></ctl-category-select-list-panel-view>\n    </div>-->\n  </div>\n\n\n</form>\n  \n  ",
                styles: ["#steps{width:100%;height:100%}.title{font-weight:700;font-size:1.2em}.title ion-label{padding:.2em 2em}#strength-button,#strength-input{display:inline-block}.strength-item{display:block;width:100%!important;margin:0 0 0 2em}#keyword-button,#keyword-input{display:inline-block}.keyword-item{display:block;width:100%!important;margin:.5em 0 0 2em}.keyword-item ion-icon,ion-grid{margin:0;padding:0}ion-grid{width:100%}ion-textarea{display:block;border:1px solid var(--ion-color-medium)}ctl-text-rich{width:100%!important}.info{margin:0 .5em;color:var(--ion-color-dark)}.form{display:block;height:5em}.form,ion-item{width:100%}ctl-feature-display-template{width:100%!important}.imgProduct{width:15vw!important;height:15vw!important;display:inline-block;margin:.1em;-o-object-fit:cover;object-fit:cover}#variationPanel,#variationPanel ion-item{width:100%}ctl-variation-display-product-template{width:100%;display:block}#price-shop,#price-wshop{width:48%;margin:0 1%;height:100%;border:1px solid var(--ion-color-medium);display:inline-block;vertical-align:top}"]
            },] }
];
ProductCreatePanelViewComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: DisplayerService },
    { type: MakerService },
    { type: VariationService },
    { type: CategoryService }
];
ProductCreatePanelViewComponent.propDecorators = {
    update: [{ type: Output }],
    valid: [{ type: Output }],
    categoriesList: [{ type: ViewChild, args: ['categoriesList', { read: CategorySelectListPanelViewComponent, static: false },] }]
};

class ProductCreatePanelViewComponentModule {
}
ProductCreatePanelViewComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    ProductCreatePanelViewComponent,
                ],
                imports: [
                    CommonModule,
                    IonicModule,
                    PipesModule,
                    FormsModule,
                    ReactiveFormsModule,
                    TextRichComponentModule,
                    FileChooserComponentModule,
                    FileChooserComponentModule,
                    CategorySelectListPanelViewComponentModule
                ],
                providers: [],
                exports: [
                    ProductCreatePanelViewComponent
                ],
                entryComponents: [],
            },] }
];

/*
 * Public API Surface of octali-shop
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Category, CategoryCreatePanelViewComponent, CategoryCreatePanelViewComponentModule, CategoryListModalComponent, CategoryListModalComponentModule, CategoryListPanelViewComponent, CategoryListPanelViewComponentModule, CategorySelectListPanelViewComponent, CategorySelectListPanelViewComponentModule, CategoryService, Declination, DeclinationService, Feature, FeatureCreatePanelViewComponent, FeatureCreatePanelViewComponentModule, FeatureFormDisplayViewComponent, FeatureFormDisplayViewComponentModule, FeatureListPanelViewComponent, FeatureListPanelViewComponentModule, FeatureService, Maker, MakerCreatePanelViewComponent, MakerCreatePanelViewComponentModule, MakerListPanelViewComponent, MakerListPanelViewComponentModule, MakerService, OctaliShopComponent, OctaliShopModule, OctaliShopService, Product, ProductCreatePanelViewComponent, ProductCreatePanelViewComponentModule, ProductListPanelViewComponent, ProductListPanelViewComponentModule, ProductService, Variation, VariationCreatePanelViewComponent, VariationCreatePanelViewComponentModule, VariationListPanelViewComponent, VariationListPanelViewComponentModule, VariationService, CategoryDaoService as ɵa, FeatureDaoService as ɵb, VariationDaoService as ɵc, MakerDaoService as ɵd, ProductDaoService as ɵe, DeclinationDaoService as ɵf, FeatureMapFormDisplayViewComponent as ɵg, FeatureValueFormDisplayViewComponent as ɵh };
//# sourceMappingURL=octali-shop.js.map
