import { EventEmitter, OnInit } from '@angular/core';
import { FormBuilder, FormGroup } from '@angular/forms';
import { DisplayerService } from 'octali-utils';
import { Category } from '../../../models/category/category';
import { Feature } from '../../../models/feature/feature';
import { FeatureService } from '../../../services/feature/feature.service';
export declare class CategoryCreatePanelViewComponent implements OnInit {
    private formBuilder;
    private displayer;
    private featureService;
    update: EventEmitter<Category>;
    deleteChildren: EventEmitter<Category>;
    category: Category | null;
    categories: Array<Category> | null;
    parent: Category | null | undefined;
    private oldParent;
    id: string;
    private children;
    features: Array<Feature>;
    private featuresId;
    private featuresList;
    categoryForm: FormGroup;
    description: string;
    hasThumb: boolean;
    thumb: any;
    extensionThumb: string;
    nameThumb: string;
    typeThumb: string;
    published: boolean;
    constructor(formBuilder: FormBuilder, displayer: DisplayerService, featureService: FeatureService);
    ngOnInit(): void;
    loadCategories(categories: Array<Category>): void;
    select(category: Category): void;
    selectCat(): void;
    selectFeature(): void;
    onContentChanged(content: string): void;
    onSubmitForm(): Promise<void>;
    thumbSelected(file: any): void;
}
