import { EventEmitter, OnInit } from '@angular/core';
import { FormBuilder, FormGroup } from '@angular/forms';
import { DisplayerService } from 'octali-utils';
import { Category } from '../../../models/category/category';
import { Feature } from '../../../models/feature/feature';
import { Maker } from '../../../models/maker/maker';
import { Product } from '../../../models/product/product';
import { Variation } from '../../../models/variation/variation';
import { CategoryService } from '../../../services/category/category.service';
import { MakerService } from '../../../services/maker/maker.service';
import { VariationService } from '../../../services/variation/variation.service';
import { CategorySelectListPanelViewComponent } from '../../category/category-select-list-panel-view/category-select-list-panel-view.component';
export declare class ProductCreatePanelViewComponent implements OnInit {
    private formBuilder;
    private displayer;
    private manufacturerService;
    private variationService;
    private categoryService;
    update: EventEmitter<Product>;
    valid: EventEmitter<any>;
    steps: string;
    categoriesList: CategorySelectListPanelViewComponent;
    descending: boolean;
    order: number;
    column: string;
    productForm: FormGroup;
    product: Product | null;
    id: string;
    description: string;
    strengths: Array<string>;
    strength: string;
    keywords: Array<string>;
    keyword: string;
    manufacturers: Array<Maker>;
    manufacturersId: Map<string, Maker> | null;
    manufacturerSelected: Maker | null;
    categories: Array<Category>;
    categoriesSelected: Array<Category>;
    features: Array<Feature>;
    variations: Array<Variation>;
    variationsSelected: Array<Variation>;
    submitAttempt: boolean;
    constructor(formBuilder: FormBuilder, displayer: DisplayerService, manufacturerService: MakerService, variationService: VariationService, categoryService: CategoryService);
    costValidator(): (group: FormGroup) => any;
    sort(): void;
    ngOnInit(): void;
    onSubmitForm(): void;
    segmentChanged(panel: any): void;
    onContentChanged(description: string): void;
    addStrength(): void;
    removeStrength(strength: string): void;
    addKeyword(): void;
    removeKeyword(keyword: string): void;
    seeTips($event: any, message: string): Promise<void>;
    select(product: Product): Promise<void>;
    save(): void;
    categorySelect(categories: Array<Category>): void;
    changeCost(): void;
}
