export declare class Product {
    private id;
    private title;
    private subtitle;
    private short_description;
    private description;
    private strengths;
    private ean;
    private manufacturer;
    private categories;
    private sold;
    private cost;
    private price;
    private sold_price;
    private discount;
    private wprice;
    private sold_wprice;
    private wdiscount;
    private key_seo;
    private description_seo;
    private hashtag;
    private shipping_cost;
    private weight;
    private width;
    private length;
    private height;
    private quantity;
    private features;
    private related_products?;
    private purchased_products?;
    private image;
    private thumb;
    private zoom;
    private images;
    private comments;
    private nbComments;
    private rating?;
    private files?;
    private variations;
    private variationName;
    private combinations;
    private nbCombinations;
    private createdAt;
    private availableAt;
    private supplyAt;
    private statut;
    private specialWeb;
    private specialShop;
    private discontinued;
    private samePrice;
    constructor();
    static setByDocument(doc: any): Product;
    getId(): string;
    setId(id: string): void;
    getTitle(): string;
    setTitle(title: string): void;
    getSubTitle(): string;
    setSubtitle(title: string): void;
    getShortDescription(): string;
    setShortdescription(description: string): void;
    getDescription(): string;
    setDescription(description: string): void;
    getEan(): string;
    setEan(ean: string): void;
    hasStrength(strength: string): boolean;
    getStrengths(): Array<string>;
    setStrengths(strengths: Array<string>): void;
    addStrength(strength: string): boolean;
    getMaker(): string;
    setMaker(manufacturer: string): void;
    hasCategory(category: string): boolean;
    getCategories(): Array<string>;
    setCategories(categories: Array<string>): void;
    addCategory(category: string): boolean;
    removeCategory(category: string): boolean;
    getSold(): boolean;
    setSold(sold: boolean): void;
    getCost(): number;
    setCost(cost: number): void;
    getPrice(): number;
    setPrice(price: number): void;
    getSoldPrice(): number;
    setSoldPrice(price: number): void;
    isDiscount(): boolean;
    setDiscount(discount: boolean): void;
    getWPrice(): number;
    setWPrice(price: number): void;
    getSoldWPrice(): number;
    setSoldWPrice(price: number): void;
    isWDiscount(): boolean;
    setWDiscount(discount: boolean): void;
    getKeySeo(): Array<string>;
    setKeySeo(keys: Array<string>): void;
    getDescriptionSeo(): string;
    setDescriptionSeo(description: string): void;
    getHashtag(): string;
    setHashtag(tag: string): void;
    getShippingCost(): number;
    setShippingCost(cost: number): void;
    getWeight(): number;
    setWeight(weight: number): void;
    getWidth(): number;
    setWidth(width: number): void;
    getHeight(): number;
    setHeight(height: number): void;
    getLength(): number;
    setLength(length: number): void;
    getQuantity(): number;
    setQuantity(quantity: number): void;
    hasFeature(feature: string): boolean;
    getFeatures(): Array<string>;
    setFeatures(features: Array<string>): void;
    addFeature(feature: string): boolean;
    removeFeature(feature: string): boolean;
    hasVariation(variation: string): boolean;
    getVariations(): Array<string>;
    setVariations(variations: Array<string>): void;
    addVariation(variation: string): boolean;
    removeVariation(variation: string): boolean;
    hasCombination(combination: string): boolean;
    getCombination(): Array<string>;
    setCombinations(combinations: Array<string>): void;
    addCombination(combination: string): boolean;
    removeCombination(combination: string): boolean;
    getImage(): Map<string, string>;
    setImage(image: Map<string, string>): void;
    getThumb(): Map<string, string>;
    setThumb(image: Map<string, string>): void;
    getZoom(): Map<string, string>;
    setZoom(image: Map<string, string>): void;
    getImages(): Array<Map<string, string>>;
    setImages(images: Array<Map<string, string>>): void;
    getCreatedAt(): string;
    setCreatedAt(date: string): void;
    getAvailableAt(): string;
    setAvailableAt(date: string): void;
    getSupplyAt(): string;
    setSupplyAt(date: string): void;
    getStatut(): string;
    setStatut(statut: string): void;
    isSpecialShop(): boolean;
    setSpecialShop(is: boolean): void;
    isSpecialWeb(): boolean;
    setSpecialWeb(is: boolean): void;
    isDiscontinued(): boolean;
    setDiscontinued(is: boolean): void;
    getNbCombination(): number;
    setNbCombination(nb: number): void;
    getVariationName(): string;
    setVariationName(name: string): void;
    isSamePrice(): boolean;
    setSamePrice(same: boolean): void;
}
