import { AngularFirestore } from '@angular/fire/firestore';
import { LoggerService } from 'octali-utils';
import { BehaviorSubject } from 'rxjs';
import { Category } from '../../models/category/category';
export declare class CategoryDaoService {
    private afStore;
    private logger;
    private categoriesSubscription;
    private categoriesObs;
    private categoriesIdObs;
    constructor(afStore: AngularFirestore, logger: LoggerService);
    getCategoriesObs(): BehaviorSubject<Array<Category> | null>;
    getCategoriesIdObs(): BehaviorSubject<Map<string, Category> | null>;
    updateChildren(category: Category): Promise<boolean>;
    setCategory(category: Category): Promise<Category | null>;
    updateCategory(category: Category): Promise<Category | null>;
    createCategory(category: Category): Promise<Category | null>;
    haveProducts(categoryId: string): Promise<boolean>;
    deleteCategory(categoryId: string): Promise<boolean>;
    productExist(categoryId: string, productId: string): boolean;
}
