import { AngularFirestore } from '@angular/fire/firestore';
import { DisplayerService, LoggerService } from 'octali-utils';
import { BehaviorSubject } from 'rxjs';
import { Feature } from '../../models/feature/feature';
export declare class FeatureDaoService {
    private afStore;
    private logger;
    private displayer;
    private featuresSubscription;
    private featuresObs;
    private featuresIdObs;
    constructor(afStore: AngularFirestore, logger: LoggerService, displayer: DisplayerService);
    getFeaturesObs(): BehaviorSubject<Array<Feature> | null>;
    getFeaturesIdObs(): BehaviorSubject<Map<string, Feature> | null>;
    setFeature(feature: Feature, display: boolean): Promise<Feature | null>;
    createFeature(feature: Feature, display: boolean): Promise<Feature | null>;
    updateFeature(feature: Feature, display: boolean): Promise<Feature | null>;
}
