import { AngularFirestore } from '@angular/fire/firestore';
import { DisplayerService, LoggerService } from 'octali-utils';
import { FileService } from 'octali-firebase-utils';
import { BehaviorSubject } from 'rxjs';
import { Maker } from '../../models/maker/maker';
export declare class MakerDaoService {
    private afStore;
    private logger;
    private filesService;
    private displayer;
    private makersSubscription;
    private makersObs;
    private makersIdObs;
    constructor(afStore: AngularFirestore, logger: LoggerService, filesService: FileService, displayer: DisplayerService);
    getMakersObs(): BehaviorSubject<Array<Maker> | null>;
    getMakersIdObs(): BehaviorSubject<Map<string, Maker> | null>;
    setMaker(maker: Maker, display?: boolean): Promise<boolean>;
    createMaker(maker: Maker, display?: boolean): Promise<boolean>;
    updateMaker(maker: Maker, display?: boolean): Promise<boolean>;
    setImage(maker: Maker): Promise<Maker>;
}
